#include parmpasser.e;
struct SolutionParams_t solsparms;
struct SolutionParams_t estparms;
struct SolutionParams_t initestparms;
/* Stuff about the State Space */
solsparms.rlnfirms=9;
solsparms.SPEC=1;
solsparms.smax=6;
solsparms.kmax=3;
solsparms.amax=3;
solsparms.maxdemand=9;

/* Parameters for Controlling Pakes-McGuire Code */
solsparms.test=1;
solsparms.noisy=1;
solsparms.alpharule=2;


solsparms.technique=2;
solsparms.distolerance=0.0001;

solsparms.thetadim=27;


/* Data */
solsparms.numberofmarkets=4;
solsparms.simmarketsnums=2000;
solsparms.simtimeperiod=50;
solsparms.simulatedata=2; // Panel Sim

solsparms.datasize=*(solsparms.rlnfirms+1)*solsparms.simtimeperiod;

/* Figure out how big the state space is */
rlnfirms=solsparms.rlnfirms;
smax=solsparms.smax;
kmax=solsparms.kmax;

binom = eye(rlnfirms+smax+1);
binom = zeros(rlnfirms+smax+1,1)~binom;
i=2;
do while (i <= rlnfirms+smax+1);  
  binom[i,2:i] = binom[i-1,2:i] + binom[i-1,1:i-1];
  i=i+1;
endo;

solsparms.wmax = binom[solsparms.rlnfirms+1+solsparms.smax,solsparms.smax+2];
solsparms.wmax2=(solsparms.maxdemand+1)*(solsparms.smax+1)*solsparms.wmax;

theta=ones(solsparms.thetadim+1,1);

D=zeros(solsparms.maxdemand+1,solsparms.maxdemand+1);

/* Control Model Computation */

if (testing==0);
	solsparms.maxiter=1000000;
	solsparms.maxround=150;
	solsparms.brfs=1;
	solsparms.ksims=10000;
	solsparms.test=1;
	solsparms.noisy=1;
	solsparms.simulatedata=2;
	solsparms.alpharule=2; 
	parmsvector=encodeparms(solsparms);
	
	initestparms=solsparms;
	initestparms.brfs=1; // Just Run through the states initially 
	initestparms.maxiter=1000000;
	initestparms.maxround=50;
	initestparms.ksims=1;
	initestparms.technique=0; /* initialize or not*/
	initestparms.alpharule=1; 
	initestvector=encodeparms(initestparms);
endif;

if (testing==1);
	solsparms.maxiter=100000;
	solsparms.maxround=2;
	solsparms.brfs=1;
	solsparms.ksims=10;
	solsparms.test=1;
	solsparms.noisy=1;
	solsparms.simulatedata=2;
	parmsvector=encodeparms(solsparms);

	initestparms=solsparms;
	initestparms.brfs=0; // Just Run through the states initially 
	initestparms.maxiter=1000000;
	initestparms.maxround=1;
	initestparms.ksims=1;
	initestparms.technique=0; /* initialize or not*/
	initestparms.alpharule=1; 
	initestvector=encodeparms(initestparms);

endif;


/* Compile and Load C files */
shell gcc -c -O6 -fPIC /rdcprojects/ny1/ny00707/transfer_proj422/ch00422/ECMA_4/pm14l.c;
shell ld -G -o /rdcprojects/ny1/ny00707/transfer_proj422/ch00422/ECMA_4/pm14l.so /rdcprojects/ny1/ny00707/transfer_proj422/ch00422/ECMA_4/pm14l.o;
dlibrary -a  /rdcprojects/ny1/ny00707/transfer_proj422/ch00422/ECMA_4/pm14l.so;

/* Setup Parameters */
Ds=10;
N=9;
Numberofobs=solsparms.datasize;

/* Load Data */
print "States " solsparms.wmax2;
print "Actions" solsparms.amax;
print "Theta Dim" solsparms.thetadim;

print "Loading Data" Numberofobs "Observations";

load gammatheta[68,1]=/rdcprojects/ny1/ny00707/transfer_proj422/ch00422/ECMA_4/modelDbeta.raw;
load DTRANZ[Ds*4,Ds]=/rdcprojects/ny1/ny00707/transfer_proj422/ch00422/ECMA_4/bootD_demand.fmt;
load DMEANS[Ds*4,2]=/rdcprojects/ny1/ny00707/transfer_proj422/ch00422/ECMA_4/bootD_demandmean.fmt;
DTRANZ[1:Ds,1:Ds]=DTRANZ[1:Ds,1:Ds]';
DTRANZ[(Ds+1):2*Ds,1:Ds]=DTRANZ[(Ds+1):2*Ds,1:Ds]';
DTRANZ[(2*Ds+1):3*Ds,1:Ds]=DTRANZ[(2*Ds+1):3*Ds,1:Ds]';
DTRANZ[(3*Ds+1):4*Ds,1:Ds]=DTRANZ[(3*Ds+1):4*Ds,1:Ds]';

load longY[XXX,N+4]=/rdcprojects/ny1/ny00707/transfer_proj422/ch00422/CONCRETE/structure/Initial.fmt;


initialstates=zeros(XXX,1);
markettype=longY[.,N+4];

for i (1,XXX,1);	
	statevec=longY[i,2:(N+3)];
	thestate=0;
	dllcall CodeStates(parmsvector,statevec,thestate);
	initialstates[i]=thestate;
	
endfor;

obsvec=sumc(markettype .eq seqa(1,1,4)');

oldDMEANS=DMEANS;
DMEANS=ln(DMEANS);

#include export.e

print "States : ";
print solsparms.wmax solsparms.wmax2;

/* Set up matrices */
hits=ones((solsparms.amax+1)*solsparms.wmax2,1);
thehits=ones(solsparms.numberofmarkets*(solsparms.amax+1)*solsparms.wmax2,1);
recenthits=ones((solsparms.amax+1)*solsparms.wmax2,1);
Q=zeros((solsparms.amax+1)*solsparms.wmax2,1);

DemandLevels=DMEANS[.,2];
print DemandLevels;
print DTRANZ;


print "Calling Function";

r=0; thedistance=100;
Misprob=0|0|1;
Mislengthdata=1211;

seeder=123;

actiondata=zeros(solsparms.datasize,1);
statedata=zeros(solsparms.datasize,1);
themarkettype=zeros(solsparms.datasize,1);
mestate=zeros(solsparms.datasize,1);
demand=zeros(solsparms.datasize,1);
comp1=zeros(solsparms.datasize,1);
comp2=zeros(solsparms.datasize,1);
plantid=zeros(solsparms.datasize,1);
year=zeros(solsparms.datasize,1);
market=zeros(solsparms.datasize,1);


obsvec=sumc(markettype .eq seqa(1,1,20)');

fulltheta=zeros(28,1);
markettheta=zeros(4,1);

proc (1)=MatPow(A,p);
local t, B;
// Matrix power
B=A;
for t (2,p,1);
	B=B*A;
endfor;
retp(B);
endp;




thedata=zeros(1,9);

ps=ones(2,1);

psstack=zeros(2,20);
pscounter=1;


// CCP INIT
Pinit=zeros(solsparms.wmax2*(solsparms.amax+1)+1,1);
load gammatheta[68,1]=/rdcprojects/ny1/ny00707/transfer_proj422/ch00422/ECMA_4/modelDbeta.raw;
thetalogit=zeros((solsparms.amax+1)*(solsparms.smax+6),1);
logitmarkettheta=zeros(3,3);

#include stripzeros.e

// Take out the zeros
newgamma=stripzeros(gammatheta);
temp=newgamma[1:15];
thetalogit[(solsparms.smax+6+1):2*(solsparms.smax+6)]=temp[15]|temp[2:7]|temp[1]|temp[8:11];
logitmarkettheta[.,1]=temp[12:14];
temp=newgamma[16:30];
thetalogit[(2*(solsparms.smax+6)+1):3*(solsparms.smax+6)]=temp[15]|temp[2:7]|temp[1]|temp[8:11];
logitmarkettheta[.,2]=temp[12:14];
temp=newgamma[31:45];
thetalogit[(3*(solsparms.smax+6)+1):4*(solsparms.smax+6)]=temp[15]|temp[2:7]|temp[1]|temp[8:11];
logitmarkettheta[.,3]=temp[12:14];

gammaprint=newgamma[1:15] ~ newgamma[16:30] ~ newgamma[31:45];
print gammaprint;


// Carefull about this statement
logitmarkettheta=logitmarkettheta';
gammalogit=thetalogit;


newP=ones(solsparms.wmax2*(solsparms.amax+1),1);
Pest=zeros(4*solsparms.wmax2*(solsparms.amax+1),1);

for mt (1,solsparms.numberofmarkets,1);
	i=mt;	
	theD=DTRANZ[(1+(i-1)*10):i*10,.];
	bigDTRANZ=vec(theD');
	mDemandL=DemandLevels[((i-1)*Ds+1):i*Ds];

	
	if (i>1);
		gammalogit[(solsparms.smax+6)+1]=thetalogit[(solsparms.smax+6)+1]+logitmarkettheta[1,i-1];
		gammalogit[(2*(solsparms.smax+6)+1)]=thetalogit[(2*(solsparms.smax+6)+1)]+logitmarkettheta[2,i-1];
		gammalogit[(3*(solsparms.smax+6)+1)]=thetalogit[(3*(solsparms.smax+6)+1)]+logitmarkettheta[3,i-1];
	endif;


	dllcall logitpredict(gammalogit,newP,mDemandL,parmsvector);
	Pest[((i-1)*solsparms.wmax2*(solsparms.amax+1)+1):(i*solsparms.wmax2*(solsparms.amax+1)),1]=newP;
	
endfor;

print "-----------------------------------------------------------------------------";
print "Baseline";
print "-----------------------------------------------------------------------------";


thedata=zeros(1,9);

@ Compute Equilibrium @
for mt (1,solsparms.numberofmarkets,1);
	i=mt;
	hits=zeros(solsparms.wmax2*(solsparms.amax+1)+1,1);
	recenthits=zeros(solsparms.wmax2*(solsparms.amax+1)+1,1);
	Q=zeros(solsparms.wmax2*(solsparms.amax+1)+1,1)+2;
	
	newP=Pest[((i-1)*solsparms.wmax2*(solsparms.amax+1)+1):(i*solsparms.wmax2*(solsparms.amax+1)),1];
	
	fulltheta=esttheta;
	fulltheta[1:3]=fulltheta[1:3]+markettheta[mt];	
	
	print fulltheta;

	solsparms.datasize=obsvec[i]*solsparms.simtimeperiod*(solsparms.rlnfirms+1);
	solsparms.simmarketsnums=obsvec[i];
	parmsvector=encodeparms(solsparms);  // Fast Rule at the start 	
		
	theD=DTRANZ[(1+(i-1)*10):i*10,.];
	bigDTRANZ=vec(theD');
	mDemandL=DemandLevels[((i-1)*Ds+1):i*Ds];

	dllcall Value_Stochastic_Algorithm(fulltheta,Q,newP,bigDTRANZ,mDemandL,hits,recenthits,thedistance,r,initestvector,seeder);
	hits=zeros(solsparms.wmax2*(solsparms.amax+1)+1,1)+20;

	recenthits=zeros(solsparms.wmax2*(solsparms.amax+1)+1,1);
	dllcall Value_Stochastic_Algorithm(fulltheta,Q,newP,bigDTRANZ,mDemandL,hits,recenthits,thedistance,r,parmsvector,seeder);

	print "Baseline Computation Done for market" mt;

	aP=reshape(newP,solsparms.wmax2,solsparms.amax+1);
	print meanc(aP);

	
	thex=selif(initialstates,markettype .eq i);
	solsparms.simmarketsnums=rows(thex);
	print rows(thex);
	parmsvector=encodeparms(solsparms);
	Mislengthdata=rows(thex);	

	dllcall SimulateData(fulltheta,Q,newP,bigDTRANZ,hits,actiondata,statedata,themarkettype,mestate,demand,comp1,plantid,year,market,Mislengthdata,ps,thex,parmsvector,seeder);	

	plantid=plantid+i*1000000;

	// Now for Producer Surplus
	print "Producer Surplus" ps;
	
	psstack[.,pscounter]=ps;
	pscounter=pscounter+1;
	
	datax=plantid~market~year~actiondata~statedata~mestate~demand~comp1~(i*ones(rows(year),1));
	thedata=thedata|datax[1:solsparms.datasize,.];
	i=exportdata(output_baseline ,thedata);

	print "Baseline Simulation Done for market" mt;

 	
endfor;
