new;
testing=0;
print "Testing " testing;
#include parmpasser.e;
struct SolutionParams_t solsparms;
struct SolutionParams_t estparms;
struct SolutionParams_t initestparms;
/* Stuff about the State Space */
solsparms.rlnfirms=9;
solsparms.SPEC=1;
solsparms.smax=6;
solsparms.kmax=3;
solsparms.amax=3;
solsparms.maxdemand=9;

/* Parameters for Controlling Pakes-McGuire Code */
solsparms.test=0;
solsparms.noisy=1;
solsparms.alpharule=1;

solsparms.technique=2;
solsparms.distolerance=0.0001;

solsparms.thetadim=27;

/* Data */
solsparms.numberofmarkets=4;
solsparms.simmarketsnums=2000;
solsparms.simtimeperiod=20;
solsparms.simulatedata=2; // Panel Sim

/* Figure out how big the state space is */
rlnfirms=solsparms.rlnfirms;
smax=solsparms.smax;
kmax=solsparms.kmax;

binom = eye(rlnfirms+smax+1);
binom = zeros(rlnfirms+smax+1,1)~binom;
i=2;
do while (i <= rlnfirms+smax+1);  
  binom[i,2:i] = binom[i-1,2:i] + binom[i-1,1:i-1];
  i=i+1;
endo;

solsparms.wmax = binom[solsparms.rlnfirms+1+solsparms.smax,solsparms.smax+2];
solsparms.wmax2=(solsparms.maxdemand+1)*(solsparms.smax+1)*solsparms.wmax;

theta=ones(solsparms.thetadim+1,1);

D=zeros(solsparms.maxdemand+1,solsparms.maxdemand+1);

/* Control Model Computation */
solsparms.maxiter=1000000;
solsparms.maxround=100;
solsparms.brfs=1;
solsparms.ksims=1000;
solsparms.test=1;
solsparms.noisy=1;
solsparms.simulatedata=0;


/* Control Estimation Computation */
estparms=solsparms;
estparms.brfs=0;
estparms.maxiter=1000000;
estparms.maxround=50;
estparms.ksims=10000;
estparms.technique=0;
estvector=encodeparms(estparms);

initestparms=solsparms;
initestparms.brfs=0;
initestparms.maxiter=1000000;
initestparms.maxround=2;
initestparms.ksims=1;
initestparms.technique=1;
initestvector=encodeparms(initestparms);

if (testing==1);
	estparms.brfs=0;
	estparms.maxiter=100000;
	estparms.maxround=10;
	estparms.ksims=10;
	maxit=2;
	estvector=encodeparms(estparms);
	initestparms.brfs=0;
	initestparms.maxiter=100000;
	initestparms.maxround=1;
	initestparms.ksims=1;
	initestvector=encodeparms(initestparms);
endif;

/* Compile and Load C files */
print "Compiling C++ Code";
shell gcc -c -O6 -fPIC pm14l.c;
shell ld -G -o pm14l.so pm14l.o; 
dlibrary -a  /rdcprojects/ny1/ny00707/transfer_proj422/ch00422/ECMA_4/pm14l.so;


/* Setup Parameters */
Ds=10;
N=9;

/* Load Data */
print "Model Boot";
print "States " solsparms.wmax2;
print "Actions" solsparms.amax;
print "Theta Dim" solsparms.thetadim;

load obsvec[1,1]=/rdcprojects/ny1/ny00707/transfer_proj422/ch00422/ECMA_4/obs2.fmt;
solsparms.datasize=obsvec[1,1];
Numberofobs=solsparms.datasize;
print "Loading Data" Numberofobs "Observations";
parmsvector=encodeparms(solsparms);

load longY[Numberofobs,N+4]=/rdcprojects/ny1/ny00707/transfer_proj422/ch00422/ECMA_4/bootD_main.fmt;
load DTRANZ[Ds*4,Ds]=/rdcprojects/ny1/ny00707/transfer_proj422/ch00422/ECMA_4/bootD_demand.fmt;
load DMEANS[Ds*4,2]=/rdcprojects/ny1/ny00707/transfer_proj422/ch00422/ECMA_4/bootD_demandmean.fmt;

load gammatheta[68,1]=/rdcprojects/ny1/ny00707/transfer_proj422/ch00422/ECMA_4/modelDbeta.raw;
DTRANZ[1:Ds,1:Ds]=DTRANZ[1:Ds,1:Ds]';
DTRANZ[(Ds+1):2*Ds,1:Ds]=DTRANZ[(Ds+1):2*Ds,1:Ds]';
DTRANZ[(2*Ds+1):3*Ds,1:Ds]=DTRANZ[(2*Ds+1):3*Ds,1:Ds]';
DTRANZ[(3*Ds+1):4*Ds,1:Ds]=DTRANZ[(3*Ds+1):4*Ds,1:Ds]';

DMEANS=ln(DMEANS);

actiondata=longY[.,1];
statedata=zeros(Numberofobs,1);
markettype=longY[.,N+4];

for i (1,Numberofobs,1);	
	statevec=longY[i,2:(N+3)];
	thestate=0;
	dllcall CodeStates(parmsvector,statevec,thestate);
	statedata[i]=thestate;
endfor;

print ((maxc(statedata)|maxc(longY[.,2:(N+3)]))~(minc(statedata)|minc(longY[.,2:(N+3)])));
#include export.e

print "States : ";
print solsparms.wmax solsparms.wmax2;

/* Set up matrices */
hits=ones((solsparms.amax+1)*solsparms.wmax2,1);
thehits=ones(solsparms.numberofmarkets*(solsparms.amax+1)*solsparms.wmax2,1);
recenthits=ones((solsparms.amax+1)*solsparms.wmax2,1);
Q=zeros((solsparms.amax+1)*solsparms.wmax2,1);

DemandLevels=DMEANS[.,2];
D=reshape(DTRANZ,4*Ds*Ds,1);

print "Calling Function";

r=0; thedistance=100;

mestate=zeros(solsparms.datasize,1);
demands=zeros(solsparms.datasize,1);
comp=zeros(solsparms.datasize,1);
plantid=zeros(solsparms.datasize,1);
year=zeros(solsparms.datasize,1);
market=zeros(solsparms.datasize,1);

/* Encode the Data*/
dllcall Descriptor(actiondata,statedata,mestate,demands,comp,parmsvector,markettype,DemandLevels);

EstGMA=zeros(solsparms.numberofmarkets*(solsparms.thetadim+1)*(solsparms.amax+1)*solsparms.wmax2,1);

/* Estimate CCP */
Pest=zeros(solsparms.numberofmarkets*solsparms.wmax2*(solsparms.amax+1),1);

/* Reset Hits */
hits=hits*0;


print "Estimating CCP";
/* Draw Data */
newP=zeros(solsparms.wmax2*(solsparms.amax+1),1);

estparms.brfs=0; estvector=encodeparms(estparms);
thetalogit=zeros((solsparms.amax+1)*(solsparms.smax+6),1);
markettheta=zeros(3,3);

#include stripzeros.e

/* Take out the zeros*/
newgamma=stripzeros(gammatheta);
temp=newgamma[1:15];
thetalogit[(solsparms.smax+6+1):2*(solsparms.smax+6)]=temp[15]|temp[2:7]|temp[1]|temp[8:11];
markettheta[.,1]=temp[12:14];

temp=newgamma[16:30];
thetalogit[(2*(solsparms.smax+6)+1):3*(solsparms.smax+6)]=temp[15]|temp[2:7]|temp[1]|temp[8:11];
markettheta[.,2]=temp[12:14];

temp=newgamma[31:45];
thetalogit[(3*(solsparms.smax+6)+1):4*(solsparms.smax+6)]=temp[15]|temp[2:7]|temp[1]|temp[8:11];
markettheta[.,3]=temp[12:14];

gammaprint=newgamma[1:15] ~ newgamma[16:30] ~ newgamma[31:45];
print gammaprint;


// Carefull about this statement
markettheta=markettheta';

gammalogit=thetalogit;
for mt (1,solsparms.numberofmarkets,1);
	i=mt;
	mDemandL=DemandLevels[((i-1)*Ds+1):i*Ds];

	
	newP=Pest[((i-1)*solsparms.wmax2*(solsparms.amax+1)+1):(i*solsparms.wmax2*(solsparms.amax+1)),1];
	if (i>1);
		gammalogit[(solsparms.smax+6)+1]=thetalogit[(solsparms.smax+6)+1]+markettheta[1,i-1];
		gammalogit[(2*(solsparms.smax+6)+1)]=thetalogit[(2*(solsparms.smax+6)+1)]+markettheta[2,i-1];
		gammalogit[(3*(solsparms.smax+6)+1)]=thetalogit[(3*(solsparms.smax+6)+1)]+markettheta[3,i-1];
	endif;

	dllcall logitpredict(gammalogit,newP,mDemandL,estvector);
	Pest[((i-1)*solsparms.wmax2*(solsparms.amax+1)+1):(i*solsparms.wmax2*(solsparms.amax+1)),1]=newP;
	aP=reshape(newP,solsparms.wmax2,solsparms.amax+1);
	print meanc(aP);
endfor;

/* Check CCPs */

predicted_action=zeros(1,1);
newstatedata=zeros(1,1);
newaction_data=zeros(1,1);
newmarkettype=zeros(1,1);


for mt (1,solsparms.numberofmarkets,1);
	i=mt;
	newP[1:solsparms.wmax2*(solsparms.amax+1)]=Pest[((i-1)*solsparms.wmax2*(solsparms.amax+1)+1):(i*solsparms.wmax2*(solsparms.amax+1)),1];
	mD=D[((i-1)*Ds*Ds+1):i*Ds*Ds];
	
	sizedata=sumc(markettype .eq mt);
	print "In Market " mt " there are" sizedata "Observations";
	predicted_action1=zeros(sizedata,1);
	statedata1=selif(statedata,markettype .eq mt);
	dllcall simulate_condP(predicted_action1,statedata1,sizedata,newP,mD,estvector);
		
	newstatedata=newstatedata|statedata1;
	predicted_action=predicted_action|predicted_action1;
	newaction_data=newaction_data|selif(actiondata, markettype .eq mt);
	newmarkettype=newmarkettype|selif(markettype, markettype .eq mt);

endfor;

newaction_data=newaction_data[2:rows(predicted_action),1];
newstatedata=newstatedata[2:rows(predicted_action),1];
newmarkettype=newmarkettype[2:rows(predicted_action),1];
predicted_action=predicted_action[2:rows(predicted_action),1];

dllcall Descriptor(predicted_action,newstatedata,mestate,demands,comp,parmsvector,newmarkettype,DemandLevels);

exportdata("CCP_check.raw",newaction_data~predicted_action~newstatedata~mestate~demands~comp~newmarkettype);

/* Do some cleaning */
clear bigG;
clear LongY;
clear aP;

seeder=123;
fulltheta=ones(28,1);

for mt (1,solsparms.numberofmarkets,1);
	i=mt;

	newP[1:solsparms.wmax2*(solsparms.amax+1)]=Pest[((i-1)*solsparms.wmax2*(solsparms.amax+1)+1):(i*solsparms.wmax2*(solsparms.amax+1)),1];
	
	mDemandL=DemandLevels[((i-1)*Ds+1):i*Ds];
	mD=D[((i-1)*Ds*Ds+1):i*Ds*Ds];
	
	NGMA=EstGMA[(i-1)*(solsparms.thetadim+1)*solsparms.wmax2*(solsparms.amax+1)+1:i*(solsparms.thetadim+1)*solsparms.wmax2*(solsparms.amax+1)];	

	// Forward Simulation
	dllcall ForwardSimulation(fulltheta,NGMA,newP,mD,mDemandL,estvector,seeder);

	// Allocate
	EstGMA[(i-1)*(solsparms.thetadim+1)*solsparms.wmax2*(solsparms.amax+1)+1:i*(solsparms.thetadim+1)*solsparms.wmax2*(solsparms.amax+1)]=NGMA;

endfor;


// In this part I reorganize the data:
// Convert to data vector
GMAvec=zeros(solsparms.datasize*(solsparms.thetadim+3)*(solsparms.amax+1),1);
dllcall convert_GMA_to_data(newstatedata,newmarkettype,EstGMA,parmsvector,GMAvec);

GMAvec=reshape(GMAvec,solsparms.datasize*(solsparms.amax+1),(solsparms.thetadim+3));
print maxc(GMAvec)~meanc(GMAvec)~minc(GMAvec);

neweractiondata=newaction_data.*.(1|1|1|1);
newerstatedata=newstatedata.*.(1|1|1|1);
newcomp=comp.*.(1|1|1|1);
newmestate=mestate.*.(1|1|1|1);
newdemands=demands.*.(1|1|1|1);
newmarkettype=newmarkettype.*.(1|1|1|1);

// Export the GMA matrix here!
exportdata("GMAFSsboot.raw",neweractiondata~newerstatedata~newcomp~newmestate~newdemands~GMAvec);

print meanc(neweractiondata~newerstatedata~newcomp~newmestate~newdemands~GMAvec)';
