/* ALLAN COLLARD-WEXLER
First Version: April 22 2005
Last Edit: November 9 2009
Makes new market data set by plant id */

cd "/rdcprojects/ny1/ny00707/transfer_proj422/ch00422/CONCRETE"
local nextstatelist="emp tae te pay sw productivity flaga flagb jmbirth jmdeath "
local plantindentity="concretesic concreteind cfn lbdnum plantindex ppn year county firmid frmnu state flaga flagb jmbirth jmdeath"
local maxplantsallowed=10
local birthvar="jmbirth"

clear
set mem 800m
use lcd3


* Generate Productivity Data
gen lmat=log(tvmc)
capture gen ltvs=log(tvs)
reg ltvs lsw ltae lmat if mod((year-1967),5)==0 & ar==0 
estimates store klems
predict prodklem, resid


reg lva lsw ltae if mod((year-1967),5)==0 
estimates store asmyears
*predict prodasmyears, resid
*Here it is important that we eliminate out of industry variables.
drop if (concretesic<0.5 | concreteind<0.5)
drop competition-nplants
drop productivity
rename prodklem productivity
drop _*
preserve

* First we fill empty slots with plant information if the plant is born in the next period
drop if (`birthvar'~=1)|(`birthvar'==.)
keep `plantindentity'
replace year=year-1
save temp, replace

restore
append using temp
* Need to generate next period's State
duplicates tag plantindex year, gen (duptag)
tab duptag
drop if duptag>0
tsset plantindex year


gen HPemp=0
replace HPemp=L.emp if (L.emp~=.)

forval t=1/20 {
replace HPemp=L.HPemp if ((HPemp<L.HPemp) & (L.HPemp~=.))
replace HPemp=L.HPemp if HPemp==.
}

sum HPemp
sum emp

replace jmbirth=0 if L.jmbirth==1
local statelist=""
foreach x of local nextstatelist {
disp "`x'"
gen F`x'=F.`x'
local statelist="`statelist' F`x'"
}
sort plantindex year
drop Fflaga Fflagb
bysort plantindex: gen Fflaga=flaga[_n+1] if year==year[_n+1]-1
bysort plantindex: gen Fflagb=flagb[_n+1] if year==year[_n+1]-1
save temp, replace

bysort county state year:gen plantorder=_n

bysort county state: egen maxplants=max(plantorder)
tab maxplants
drop if maxplants>`maxplantsallowed'
drop duptag
compress
save temp, replace

order county state year plantorder
reshape wide concretesic-productivity F* HPemp, i(county state year) j(plantorder)
save temp, replace
sort  state county year
preserve
* Bring in lcd4 vars for the appropriate year
use lcd4, clear
sort state county year
save lcd4, replace
restore
merge state county year using lcd4
tab year _merge
drop if _merge==1
save temp, replace


* Now we do screens
drop if year<1976|year==2000
*keep if mod((year-1967),5)==0 
drop if state==66|state==72
save lcd5c, replace


/*
duplicates drop county state year, force
reshape long concretesic-productivity F* HPemp, i(county state year) j(plantorder)

*/