/* This file converts the construction information from the LBD to county (for now) aggregates of payroll and employement
ALLAN COLLARD-WEXLER
August 13 2004
November 9 2004
In this case we will not do a fillin operation since all counties with no employement (missing data are 0 by definition)
*/
clear

set matsize 800
set mem 800m

insheet using "/home/ch0422colla304/WORK/CONCRETE/Raw Data files from SAS/ConstructionPanel.csv"
* This previous file was created by extracting sics 15* 16* 17* from the LBD using extractconstruction
save "/home/ch0422colla304/WORK/CONCRETE/ConstructionPanel.dta",replace
* COUNTY/YEAR/SIC
* Load the file
use "/home/ch0422colla304/WORK/CONCRETE/ConstructionPanel.dta"
rename yr year
drop if year==.
drop if state==.
drop if county==.
drop if sic==.
rename emp empconstruction
rename pay payconstruction
*Sort it
sort year state county sic

* Now create aggregates with the collapse statement
collapse (sum) empconstruction payconstruction, by(year state county sic)

* Save it
save "/home/ch0422colla304/WORK/CONCRETE/ConstructionCSICAggregates.dta" , replace
* Add the counties which have zeros in them in this particular year


use "/home/ch0422colla304/WORK/CONCRETE/ConstructionCSICAggregates.dta"
gen countycode=state*1000+county
fillin year countycode sic
mvencode empconstruction,mv(0)
mvencode payconstruction,mv(0)
save "/home/ch0422colla304/WORK/CONCRETE/ConstructionCSICAggregates.dta", replace
do makeconcreteusagestats */
use "/home/ch0422colla304/WORK/CONCRETE/ConstructionCSICAggregates.dta"
* COUNTY/YEAR

* Sort it
sort year state county

* Now create aggregates with the collapse statemente
collapse (sum) empconstruction payconstruction empintensity payintensity, by(year state county)

sort year state county

gen countycode=state*1000+county
/*fillin year countycode
replace county=mod(countycode,1000) if county==.
replace state=int(countycode/1000) if state==.
mvencode empconstruction,mv(0) override
mvencode payconstruction,mv(0) override
*/
replace year=year+1900
sort countycode year
drop countycode
*drop _fillin
sort state county year
* Save it
save "/home/ch0422colla304/WORK/CONCRETE/ConstructionCAggregates.dta" , replace


* We made a mistake the first time we did this merger (means instead of sum's in the collapse
clear
use "/home/ch0422colla304/WORK/CONCRETE/lcd2.dta"
drop *empconstruction *payconstruction

sort state county year
merge using "/home/ch0422colla304/WORK/CONCRETE/ConstructionCAggregates.dta"
tab _merge
drop _merge
save "/home/ch0422colla304/WORK/CONCRETE/lcd2.dta", replace
display ("end")
exit







