*-------------------------------------------------------------------------
* Allan Collard-Wexler
* June 20, 2004
*
* THIS CODE CONSTRUCTS MEASURES OF READY-MIX APPARTENANCE FROM THE LBD 
* AND THE CMF UNION AMS
*-------------------------------------------------------------------------
clear

use "/home/ch0422colla304/WORK/CONCRETE/lcd.dta"

* First we construct a measure if the sic code corresponds to the ready mix sector
drop concretesic
gen concretesic=(sic==3273|(sic>=327300 & sic<327400)) if sic~=.
* First we construct a measure if the ind code corresponds to the ready mix sector
drop concreteind
gen concreteind=(ind==3273|ind==327320) if ind~=.
tab concreteind concretesic
*save "/home/ch0422colla304/WORK/CONCRETE/temp.dta", replace

* To figure out the answer to this question, we can see how often an lbdnum belongs to concrete
sort plantindex
collapse (mean) concretesic concreteind, by (plantindex)
save "/home/ch0422colla304/WORK/CONCRETE/plantindexconcrete.dta", replace
clear

*Now we can merge back in
clear
use "/home/ch0422colla304/WORK/CONCRETE/lcd.dta"
sort plantindex
drop _merge
merge plantindex using "/home/ch0422colla304/WORK/CONCRETE/plantindexconcrete.dta"
tab _merge
save "/home/ch0422colla304/WORK/CONCRETE/lcd.dta", replace





