* This program creates an index file of all cfn's which are included in the subset of plants in the union of the LRD;
* And the LBD which have SIC code 3273 at any point in time.;



* Standard library definition;
LIBNAME Conlib '/home/ch0422colla304/WORK/CONCRETE';
LIBNAME Lbd '/economic/lbd/microdata';
LIBNAME Asm '/economic/asm/microdata';
LIBNAME Cmf '/economic/cmf/microdata';



* First we take the union of panel data from cmf/asm (lrd) and the lbd where observations are selected if ind==3273;

* In a first stage we sort all of these data sets;
DATA Conlib.Asmpanels;
SET Conlib.Asmpanel;
PROC SORT;
BY cfn;
RUN;

DATA Conlib.Cmfpanels;
SET Conlib.Cmfpanel;
PROC SORT;
BY cfn;
RUN;

DATA Conlib.Lbdpanels;
SET Conlib.Lbdpanel;
PROC SORT;
BY cfn;
RUN;



*Next we merge;
DATA Conlib.Temp;
MERGE Conlib.Asmpanels (KEEP = cfn )
      Conlib.Cmfpanels (KEEP = cfn )
      Conlib.Lbdpanels (KEEP = cfn );
BY cfn;
RUN;
DATA Conlib.Index;
SET Conlib.Temp;
PROC SORT NODUPRECS;
BY cfn;
RUN;

%MACRO ExtractLBDNUM(year,dataset);
        *Sort the data;
        DATA Conlib.Temp;
        SET &dataset..&dataset.19&year.b (KEEP = cfn lbdnum);
        PROC SORT;
        BY cfn;
        RUN;
        *Merge the data;
        DATA Conlib.Temp3;
        MERGE Conlib.Index ( IN = Inindex ) Conlib.Temp ( IN = Inasm);
        BY cfn;
        *Only keep the data that is in both datasets;
        IF Inindex=1 & Inasm=1;
        RUN;
        * Now merge these numbers with the master file;
        DATA Conlib.Temp4;
        SET Conlib.Lbdnumindex;
        RUN;
        DATA Conlib.Lbdnumindex;
        SET Conlib.Temp4 Conlib.Temp3;
        RUN;
%MEND ExtractLBDNUM;



*However, we should notice that if the CFN number changes, we may lose these observations, in particular when looking at; *the LBD informtion;
*To counter this, we will extract all LBDnumbers which have any observation equal to the CFN in the previous file;
*Then we use the set of all these LBD numbers as the basis for selecting the set of CFN's we will want to extract;

*First, find all LBDnumbers which have a matched CFN sometime in their history;
DATA Conlib.Lbdnumindex;
RUN;


*Then the LBD's;
%ExtractLBDNUM(99,Lbd);
%ExtractLBDNUM(98,Lbd);
%ExtractLBDNUM(97,Lbd);
%ExtractLBDNUM(96,Lbd);
%ExtractLBDNUM(95,Lbd);
%ExtractLBDNUM(94,Lbd);
%ExtractLBDNUM(93,Lbd);
%ExtractLBDNUM(92,Lbd);
%ExtractLBDNUM(91,Lbd);
%ExtractLBDNUM(90,Lbd);
%ExtractLBDNUM(89,Lbd);
%ExtractLBDNUM(88,Lbd);
%ExtractLBDNUM(87,Lbd);
%ExtractLBDNUM(86,Lbd);
%ExtractLBDNUM(85,Lbd);
%ExtractLBDNUM(84,Lbd);
%ExtractLBDNUM(83,Lbd);
%ExtractLBDNUM(82,Lbd);
%ExtractLBDNUM(81,Lbd);
%ExtractLBDNUM(80,Lbd);
%ExtractLBDNUM(79,Lbd);
%ExtractLBDNUM(78,Lbd);
%ExtractLBDNUM(77,Lbd);
%ExtractLBDNUM(76,Lbd);

* Clean up the file (duplicates);
DATA Conlib.Temp;
SET Conlib.Lbdnumindex (KEEP = Lbdnum);
PROC SORT NODUPRECS;
BY lbdnum;
RUN;

DATA Conlib.Lbdnumindex;
SET Conlib.Temp;
RUN;

* AT this point we have all the relevant LBDNUMs now we need to search for all the CFNs associated with these;
%MACRO ExtractCFNs(year,dataset);
        *Sort the data;
        DATA Conlib.Temp;
        SET &dataset..&dataset.19&year.b (KEEP = cfn lbdnum);
        PROC SORT;
        BY lbdnum;
        RUN;
        *Merge the data;
        DATA Conlib.Temp1;
        MERGE Conlib.Lbdnumindex ( IN = Inindex ) Conlib.Temp ( IN = Inasm);
        BY lbdnum;
        *Only keep the data that is in both datasets;
        IF Inindex=1 & Inasm=1;
        RUN;
        * Now merge these numbers with the master file;
        DATA Conlib.Temp4;
        SET Conlib.Newindex;
        RUN;
        DATA Conlib.Newindex;
        SET Conlib.Temp4 Conlib.Temp1;
        RUN;
%MEND ExtractCFNs;

DATA Conlib.Newindex;
RUN;

%ExtractCFNs(99,Lbd);
%ExtractCFNs(98,Lbd);
%ExtractCFNs(97,Lbd);
%ExtractCFNs(96,Lbd);
%ExtractCFNs(95,Lbd);
%ExtractCFNs(94,Lbd);
%ExtractCFNs(93,Lbd);
%ExtractCFNs(92,Lbd);
%ExtractCFNs(91,Lbd);
%ExtractCFNs(90,Lbd);
%ExtractCFNs(89,Lbd);
%ExtractCFNs(88,Lbd);
%ExtractCFNs(87,Lbd);
%ExtractCFNs(86,Lbd);
%ExtractCFNs(85,Lbd);
%ExtractCFNs(84,Lbd);
%ExtractCFNs(83,Lbd);
%ExtractCFNs(82,Lbd);
%ExtractCFNs(81,Lbd);
%ExtractCFNs(80,Lbd);
%ExtractCFNs(79,Lbd);
%ExtractCFNs(78,Lbd);
%ExtractCFNs(77,Lbd);
%ExtractCFNs(76,Lbd);


* Keep the old index file;
DATA Conlib.Oldindex;
SET Conlib.Index;
RUN;
* Clean up the file (duplicates);
DATA Conlib.Temp;
SET Conlib.NewIndex (KEEP = cfn) Conlib.Oldindex (KEEP = cfn);
PROC SORT NODUPRECS;
BY cfn;
RUN;

* Do the susbtitution;
DATA Conlib.Index;
SET Conlib.Temp;
RUN;






*Now merge all of these together;



%MACRO Extract(year,dataset);
        *Sort the data;
        DATA Conlib.Temp;
        SET &dataset..&dataset.00&year;
        PROC SORT;
        BY cfn;
        RUN;
        *Merge the data;
        DATA Conlib.&dataset.&year.b;
        MERGE Conlib.Index ( IN = Inindex ) Conlib.Temp ( IN = Inasm);
        BY cfn;
        *Only keep the data that is in both datasets;
        IF Inindex=1 & Inasm=1;
        RUN;
%MEND Extract;

%MACRO Extractlbd(year,dataset);
        *Sort the data;
        DATA Conlib.Temp;
        SET &dataset..&dataset.19&year.b;
        PROC SORT;
        BY lbdnum;
        RUN;
        *Merge the data;
        DATA Conlib.&dataset.&year.b;
	*Note that we are using the LBDNUBER INDEX here (issue without this);
        MERGE Conlib.Lbdnumindex ( IN = Inindex ) Conlib.Temp ( IN = Inasm);
        BY lbdnum;
        *Only keep the data that is in both datasets;
        IF Inindex=1 & Inasm=1;
        RUN;
%MEND Extractlbd;


*First the ASMs;
%Extract(00,Asm);
%Extract(99,Asm);
%Extract(98,Asm);
%Extract(96,Asm);
%Extract(95,Asm);
%Extract(94,Asm);
%Extract(93,Asm);
%Extract(91,Asm);
%Extract(90,Asm);
%Extract(89,Asm);
%Extract(88,Asm);
%Extract(86,Asm);
%Extract(85,Asm);
%Extract(84,Asm);
%Extract(83,Asm);
%Extract(81,Asm);
%Extract(80,Asm);
%Extract(79,Asm);
%Extract(78,Asm);
%Extract(76,Asm);
%Extract(75,Asm);
%Extract(74,Asm);
%Extract(73,Asm);

*Then the LBD's;
%Extractlbd(99,Lbd);
%Extractlbd(98,Lbd);
%Extractlbd(97,Lbd);
%Extractlbd(96,Lbd);
%Extractlbd(95,Lbd);
%Extractlbd(94,Lbd);
%Extractlbd(93,Lbd);
%Extractlbd(92,Lbd);
%Extractlbd(91,Lbd);
%Extractlbd(90,Lbd);
%Extractlbd(89,Lbd);
%Extractlbd(88,Lbd);
%Extractlbd(87,Lbd);
%Extractlbd(86,Lbd);
%Extractlbd(85,Lbd);
%Extractlbd(84,Lbd);
%Extractlbd(83,Lbd);
%Extractlbd(82,Lbd);
%Extractlbd(81,Lbd);
%Extractlbd(80,Lbd);
%Extractlbd(79,Lbd);
%Extractlbd(78,Lbd);
%Extractlbd(77,Lbd);
%Extractlbd(76,Lbd);

*The the CMF's;
%Extract(97,Cmf);
%Extract(92,Cmf);
%Extract(87,Cmf);
%Extract(82,Cmf);
%Extract(77,Cmf);
%Extract(72,Cmf);
%Extract(67,Cmf);
%Extract(63,Cmf);



DATA Conlib.Lbdpanelb;
SET Conlib.Lbd99b
Conlib.Lbd98b
Conlib.Lbd97b
Conlib.Lbd96b
Conlib.Lbd95b
Conlib.Lbd94b
Conlib.Lbd93b
Conlib.Lbd92b
Conlib.Lbd91b
Conlib.Lbd90b
Conlib.Lbd89b
Conlib.Lbd88b
Conlib.Lbd87b
Conlib.Lbd86b
Conlib.Lbd85b
Conlib.Lbd84b
Conlib.Lbd83b
Conlib.Lbd82b
Conlib.Lbd81b
Conlib.Lbd80b
Conlib.Lbd79b
Conlib.Lbd78b
Conlib.Lbd77b
Conlib.Lbd76b;
RUN;

DATA Conlib.Cmfpanelb;
SET Conlib.Cmf97b
Conlib.Cmf92b
Conlib.Cmf87b
Conlib.Cmf82b
Conlib.Cmf77b
Conlib.Cmf72b
Conlib.Cmf67b
Conlib.Cmf63b;
run;

*Now we export;
DATA Conlib.ASMpanelb;
SET Conlib.Asm99b
Conlib.Asm98b
Conlib.Asm96b
Conlib.Asm95b
Conlib.Asm94b
Conlib.Asm93b
Conlib.Asm91b
Conlib.Asm90b
Conlib.Asm89b
Conlib.Asm88b
Conlib.Asm86b
Conlib.Asm85b
Conlib.Asm84b
Conlib.Asm83b
Conlib.Asm81b
Conlib.Asm80b
Conlib.Asm79b
Conlib.Asm78b
Conlib.Asm76b
Conlib.Asm75b
Conlib.Asm74b
Conlib.Asm73b
Conlib.Asm00b;
run;


*Finally, we add the neccessary information to the index files;
*For this procedure we will use the fact that there a many to one mappping;
*Between the cfn and the (ppn/lbdnum);


DATA Conlib.Temp1;
SET Conlib.Asmpanelb;
PROC SORT;
BY cfn;
RUN;

DATA Conlib.Temp2;
SET Conlib.Cmfpanelb;
PROC SORT;
BY cfn;
RUN;

DATA Conlib.Temp3;
SET Conlib.Lbdpanelb;
PROC SORT;
BY cfn;
RUN;



DATA Conlib.Temp;
MERGE Conlib.Index (KEEP = cfn)
      Conlib.Temp1 (KEEP = cfn ppn)
      Conlib.Temp2 (KEEP = cfn ppn)
      Conlib.Temp3 (KEEP = cfn lbdnum);
BY cfn;
RUN;
DATA Conlib.MasterIndex;
SET Conlib.Temp;
PROC SORT NODUPRECS;
BY cfn;
RUN;

*Now we can export all of these files into stata;

PROC EXPORT DATA= Conlib.Cmfpanelb
            OUTFILE= "/home/ch0422colla304/WORK/CONCRETE/Cmfpanelb.csv"
            DBMS=CSV REPLACE;
RUN;

PROC EXPORT DATA= Conlib.Asmpanelb
            OUTFILE= "/home/ch0422colla304/WORK/CONCRETE/Asmpanelb.csv"
            DBMS=CSV REPLACE;
RUN;

PROC EXPORT DATA= Conlib.Lbdpanelb
            OUTFILE= "/home/ch0422colla304/WORK/CONCRETE/Lbdpanelb.csv"
            DBMS=CSV REPLACE;
RUN;

PROC EXPORT DATA= Conlib.Masterindex
            OUTFILE= "/home/ch0422colla304/WORK/CONCRETE/MasterIndex.csv"
            DBMS=CSV REPLACE;
RUN;

*Lets redo all of this for the prod and mat dataset in the ASM/CMF;

%MACRO Extractprod(year,dataset);
        *Sort the data;
        DATA Conlib.Temp;
        SET &dataset..&dataset.00&year.prod;
        PROC SORT;
        BY cfn;
        RUN;
        *Merge the data;
        DATA Conlib.&dataset.&year.prodb;
        MERGE Conlib.Index ( IN = Inindex ) Conlib.Temp ( IN = Inasm);
        BY cfn;
        *Only keep the data that is in both datasets;
        IF Inindex=1 & Inasm=1;
        RUN;
%MEND Extractprod;

*First the ASMs;
%Extractprod(00,Asm);
%Extractprod(99,Asm);
%Extractprod(98,Asm);
%Extractprod(96,Asm);
%Extractprod(95,Asm);
%Extractprod(94,Asm);
%Extractprod(93,Asm);
%Extractprod(91,Asm);
%Extractprod(90,Asm);
%Extractprod(89,Asm);
%Extractprod(88,Asm);
%Extractprod(86,Asm);
%Extractprod(85,Asm);
%Extractprod(84,Asm);
%Extractprod(83,Asm);
%Extractprod(81,Asm);
%Extractprod(80,Asm);
%Extractprod(79,Asm);
%Extractprod(78,Asm);
%Extractprod(76,Asm);
%Extractprod(75,Asm);
%Extractprod(74,Asm);
%Extractprod(73,Asm);


*The the CMF's;
%Extractprod(97,Cmf);
%Extractprod(92,Cmf);
%Extractprod(87,Cmf);
%Extractprod(82,Cmf);
%Extractprod(77,Cmf);
%Extractprod(72,Cmf);
%Extractprod(67,Cmf);
%Extractprod(63,Cmf);

%MACRO Extractmat(year,dataset);
        *Sort the data;
        DATA Conlib.Temp;
        SET &dataset..&dataset.00&year.mat;
        PROC SORT;
        BY cfn;
        RUN;
        *Merge the data;
        DATA Conlib.&dataset.&year.matb;
        MERGE Conlib.Index ( IN = Inindex ) Conlib.Temp ( IN = Inasm);
        BY cfn;
        *Only keep the data that is in both datasets;
        IF Inindex=1 & Inasm=1;
        RUN;
%MEND Extractmat;


*The the CMF's;
%Extractmat(97,Cmf);
%Extractmat(92,Cmf);
%Extractmat(87,Cmf);
%Extractmat(82,Cmf);
%Extractmat(77,Cmf);
%Extractmat(72,Cmf);
%Extractmat(67,Cmf);
%Extractmat(63,Cmf);

*Now we export;
DATA Conlib.ASMpanelprodb;
SET Conlib.Asm99prodb
Conlib.Asm98prodb
Conlib.Asm96prodb
Conlib.Asm95prodb
Conlib.Asm94prodb
Conlib.Asm93prodb
Conlib.Asm91prodb
Conlib.Asm90prodb
Conlib.Asm89prodb
Conlib.Asm88prodb
Conlib.Asm86prodb
Conlib.Asm85prodb
Conlib.Asm84prodb
Conlib.Asm83prodb
Conlib.Asm81prodb
Conlib.Asm80prodb
Conlib.Asm79prodb
Conlib.Asm78prodb
Conlib.Asm76prodb
Conlib.Asm75prodb
Conlib.Asm74prodb
Conlib.Asm73prodb
Conlib.Asm00prodb;
run;

DATA Conlib.Cmfpanelprodb;
SET Conlib.Cmf97prodb
Conlib.Cmf92prodb
Conlib.Cmf87prodb
Conlib.Cmf82prodb
Conlib.Cmf77prodb
Conlib.Cmf72prodb
Conlib.Cmf67prodb
Conlib.Cmf63prodb;
run;


DATA Conlib.Cmfpanelmatb;
SET Conlib.Cmf97matb
Conlib.Cmf92matb
Conlib.Cmf87matb
Conlib.Cmf82matb
Conlib.Cmf77matb
Conlib.Cmf72matb
Conlib.Cmf67matb
Conlib.Cmf63matb;
run;


*Now we can export all of these files into stata;

PROC EXPORT DATA= Conlib.Cmfpanelprodb
            OUTFILE= "/home/ch0422colla304/WORK/CONCRETE/Cmfpanelprodb.csv"
            DBMS=CSV REPLACE;
RUN;
PROC EXPORT DATA= Conlib.Cmfpanelmatb
            OUTFILE= "/home/ch0422colla304/WORK/CONCRETE/Cmfpanelmatb.csv"
            DBMS=CSV REPLACE;
RUN;


PROC EXPORT DATA= Conlib.Asmpanelprodb
            OUTFILE= "/home/ch0422colla304/WORK/CNUS/Asmpanelprodb.csv"
            DBMS=CSV REPLACE;
RUN;
