*-------------------------------------------------------------------------
* Allan Collard-Wexler
* July 27, 2004
*
* RESHAPE PRODUCT TRAILER FOR IMPORT INTO LCD
*-------------------------------------------------------------------------


* This do file reshapes the product trailers to be merged with data on firm in our LCD *(longitudinal concrete data)
* Note that we will use variables corresponding to the NAICS product codes of the most used * products (value weighted of course
clear
use cmfprodpanelb

* First we will convert this data set to single observation style
sort cfn year seqnprod
drop in 41233

drop seqnmst
quietly reshape wide ppn- pvit,i(cfn year) j(seqnprod)

local constantvar "ppn tvs tvps tvpsd ind statp"
local nonconstantvar "curpc pcol pcolf naicspc ppc pqit pqp pqpc pqpf pqs pqsf pv pvf pvit"


foreach k of local constantvar {
rename `k'1 `k'
forvalues x=2/27 {
	drop `k'`x'
}
}

* Define the set of NAICS product codes we want to treat differently
local naicsprod "3273000 3273011 9998900 3273002 3721500 3711111 3711301 3272271 2951051 3271017 1442001 3271011 1442000 3241012 9998098 3721050 3272200 3241013 2141225 2869600 3721855"

* Generate new variables with these
local newvar "ppc pqit pqp pqpc pqpf pqs pqsf pv pvf pvit"
local newvarstring "ppc pqpf pqsf pvf"
local newvarnum "pqit pqp pqpc pqs pv pvit"

* First we need to make sure the new variables have the same type as the old ones
recast str15 ppc1 pqpf1 pqsf1 pvf1
quietly {
foreach x of local naicsprod {
	foreach z of local newvarstring {
		gen `z'`x'=`z'1
		replace `z'`x'="."
	}
	foreach z of local newvarnum {
		gen `z'`x'=`z'1
		replace `z'`x'=.
	}

}
}

quietly {
foreach x of local naicsprod {
forvalues y=1/27 {
	foreach z of local newvarstring {
		quietly replace `z'`x'=`z'`y' if curpc`y'=="`x'"
		quietly replace `z'`y'="." if curpc`y'=="`x'"
				}
	foreach z of local newvarnum {
		quietly replace `z'`x'=`z'`y' if curpc`y'=="`x'"
		quietly replace `z'`y'=. if curpc`y'=="`x'"
				}

	}
}
}



quietly compress

save newmatprod, replace
