/* This file holds parameters */


/* Structure to Pass to the C Code */
struct SolutionParams_t {
	scalar rlnfirms; /* Number of Firms */
	scalar spec; /* Model Choice */
	scalar thetadim; /* Number of Parameters */
	scalar smax; /* Maximum Number of Firm States */
	scalar kmax; /* Number of Firm States Currently  (without lags )*/
	scalar amax; /* Actions you can choose 0-AMAX*/
	scalar maxdemand; /* Highest Demand State you can reach 0-MAXDEMAND */
	scalar numberofmarkets; /* Number of Different Market Types */

	scalar wmax; /* Number of distinct states for other firms */
	scalar wmax2; /* Total number of states */

	scalar datasize; /* Size of Data Set */
	scalar simmarketsnums; /* Number of different counties */
	scalar simtimeperiod; /* Number of Periods */
	
	scalar maxiter; /* After how many iterations do we check convergence */
	scalar maxround; /* How many rounds do we do */
	scalar simulatedata; /* Do you simulate data */
	scalar brfs; /* best-response or full solution */
	scalar ksims; /* Number of simulations in the test */
	scalar technique; /* How you solve the game */
	

	scalar distolerance; /* How close to the equilibrium P */
	scalar minimizer; /* Minimization Routine used */
	scalar test; /* Fershmann-Pakes Test */
	scalar noisy; /* Print output */
	scalar alpharule; /* Function used to update value G=alpha*(profit+E beta G(s'))+(1-alpha)*G */
};

proc (1)=encodeparms(struct SolutionParams_t solsparms);
local parmvector;
parmvector=zeros(50,1);
parmvector[1]=solsparms.rlnfirms;
parmvector[2]=solsparms.spec;
parmvector[3]=solsparms.thetadim;
parmvector[4]=solsparms.smax;
parmvector[5]=solsparms.kmax;
parmvector[6]=solsparms.amax;
parmvector[7]=solsparms.maxdemand;
parmvector[8]=solsparms.numberofmarkets;
parmvector[9]=solsparms.wmax;
parmvector[10]=solsparms.wmax2;
parmvector[11]=solsparms.datasize;
parmvector[12]=solsparms.simmarketsnums;
parmvector[13]=solsparms.simtimeperiod;
parmvector[14]=solsparms.maxiter;
parmvector[15]=solsparms.maxround;
parmvector[16]=solsparms.simulatedata;
parmvector[17]=solsparms.brfs;
parmvector[18]=solsparms.ksims;
parmvector[19]=solsparms.technique;
parmvector[20]=solsparms.distolerance;
parmvector[21]=solsparms.minimizer;
parmvector[22]=solsparms.test;
parmvector[23]=solsparms.noisy;
parmvector[24]=solsparms.alpharule;

retp(parmvector);
endp;