/* Euler's Constant */
#define eulerc 0.577215665

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <omp.h>
#include <math.h>



/* Market Description type */
struct market_t {
       int tuple[RLNFIRMS];
       int demand;
       int me;
};



/* Parameter Passing Structure */
struct SolutionParams_t {
	double rlnfirms; /* Number of Firms */
	double spec; /* Model Choice */
	double thetadim; /* Number of Parameters */
	double smax; /* Maximum Number of Firm States */
	double kmax; /* Number of Firm States Currently  (without lags )*/
	double amax; /* Actions you can choose 0-AMAX*/
	double maxdemand; /* Highest Demand State you can reach 0-MAXDEMAND */
	double numberofmarkets; /* Number of Different Market Types */

	double wmax; /* Number of distinct states for other firms */
	double wmax2; /* Total number of states */

	double datasize; /* Size of Data Set */
	double simmarketsnums; /* Number of different counties */
	double simtimeperiod; /* Number of Periods */

	double maxiter; /* After how many iterations do we check convergence */
	double maxround; /* How many rounds do we do */
	double simulatedata; /* Do you simulate data */
	double brfs; /* best-response or full solution */
	double ksims; /* Number of simulations in the test */
	double technique; /* How you solve the game */


	double distolerance; /* How close to the equilibrium P */
	double minimizer; /* Minimization Routine used */
	double test; /* Perform the Pakes-Fershmann Test for correctness of solution */
	double noisy; /* Print Intermediate Output */
	double alpharule; /* How do you update the Q function based on number of hits */
};


int encode();
void bubblesort2();
void decode();
void profitNP();
int drawerconda();
void cumtranzer();
void cumtranzeri();
void choiceprobabilitiesNP();
int linkfunction();
void buildbinom();
void decodeparms();
int ForwardSimulation();

/*-------------------------------------------------------------------------------*/
void decodeparms(struct SolutionParams_t * solsparms,const double parmvector[])
{
/* Take a vector of parameters and put them into a structure */
solsparms->rlnfirms=parmvector[0];
solsparms->spec=parmvector[1];
solsparms->thetadim=parmvector[2];
solsparms->smax=parmvector[3];
solsparms->kmax=parmvector[4];
solsparms->amax=parmvector[5];
solsparms->maxdemand=parmvector[6];
solsparms->numberofmarkets=parmvector[7];
solsparms->wmax=parmvector[8];
solsparms->wmax2=parmvector[9];
solsparms->datasize=parmvector[10];
solsparms->simmarketsnums=parmvector[11];
solsparms->simtimeperiod=parmvector[12];
solsparms->maxiter=parmvector[13];
solsparms->maxround=parmvector[14];
solsparms->simulatedata=parmvector[15];
solsparms->brfs=parmvector[16];
solsparms->ksims=parmvector[17];
solsparms->technique=parmvector[18];
solsparms->distolerance=parmvector[19];
solsparms->minimizer=parmvector[20];
solsparms->test=parmvector[21];
solsparms->noisy=parmvector[22];
solsparms->alpharule=parmvector[23];
}
/*-------------------------------------------------------------------------------*/

int linkfunction(int action,int mestate) {
/* Given a State and and an action, draw an state for a single firm in the future */
int statemeprime,i, k, klag, j, remains, code;

/* Update State if it currently the highest */
i=mestate;
if (i==0) {
	k=0; klag=0;}
if (i==1) {
	k=1; klag=1;}
if (i==2) {
	k=1; klag=2;}
if (i==3) {
	k=1; klag=3;}
if (i==4) {
	k=2; klag=2;}
if (i==5) {
	k=2; klag=3;}	
if (i==6) {
	k=3; klag=3;}
	
k=action;
if (action>klag)
	klag==action;
/* Encode the State */
if (k==0)
	code=0;
if ((k==1)&&(klag<2))
	code=1;
if ((k==1)&&(klag==2))	
	code=2;
if ((k==1)&&(klag==3))	
	code=3;
if ((k==2)&&(klag<3))	
	code=4;
if ((k==2)&&(klag==3))	
	code=5;
if (k==3)
	code=6;


statemeprime=code;

return statemeprime;
}
/*-------------------------------------------------------------------------------*/
void profitNP(double profitholder[],double theta[],int statetoday, int stateyesterday, int binom[], int wmax,struct market_t * markettoday,struct market_t * marketyesterday,struct pcomp_t * pcomps, int ntuple[],double DemandLevels[])
{
       int i, j, k, t, me, klag,remains, code;
       double theprofit;
	  /* Decode the State */
       decode(markettoday,statetoday,binom,wmax,ntuple);
       decode(marketyesterday,stateyesterday,binom,wmax,ntuple);

/* Decode the state */
	
	i=markettoday->me;
	if (i==0) {
		k=0; klag=0;}
	if (i==1) {
		k=1; klag=1;}
	if (i==2) {
		k=1; klag=2;}
	if (i==3) {
		k=1; klag=3;}
	if (i==4) {
		k=2; klag=2;}
	if (i==5) {
		k=2; klag=3;}	
	if (i==6) {
		k=3; klag=3;}
		

 /* Fixed Costs */
	   for (i=1;i<(KMAX+1);i++)
	   	 pcomps->activevec[i-1]=(k==i);

	   /* Competition */
	   int totalcomp=0;
	   for (i=0;i<RLNFIRMS;i++)
		   totalcomp=totalcomp+(markettoday->tuple[i]>0);
	   
	   int q=0,ij=0;
	   /* Transition Costs */
	   for (i=0;i<(SMAX+1);i++){
	   	ij=0;
	   	if (i==1||i==2||i==3)
			ij=1;
		if (i==4||i==5)
			ij=2;
		if (i==6)
			ij=3;

   	   for (j=1;j<(AMAX+1);j++) 
		   	if (ij!=j) {
			pcomps->transition[q]=(marketyesterday->me==i)*(k==j);
		   	q++;
	   	    }
			   
	   }	
		
	/* Put it together */
	j=0;
	for (i=1;i<(KMAX+1);i++,j++)
	   profitholder[j]=((double) pcomps->activevec[i-1]);

	/* Demand */
	for (i=1;i<(KMAX+1);i++,j++)
		profitholder[j]=((double) (k==i))*DemandLevels[markettoday->demand];
	
	
	for (t=1;t<(KMAX+1);t++) {
			profitholder[j]=((double) (k==t))*((double) totalcomp >0);
			j++;
			
			profitholder[j]=0.0;
			if (totalcomp>1)
				profitholder[j]=((double) (k==t))*log(((double) totalcomp));		
			j++;}   
			
	for (i=0;i<q;i++,j++){
		 profitholder[j]=((double) pcomps->transition[i]);
		}

}
/*-------------------------------------------------------------------------------*/
void decode(struct market_t * market, int code, int binom[], int wmax,int ntuple[])
{
/* This procedure takes a previously encoded number, and decodes it into
 a weakly descending n-tuple (n = nfirms)                              */
int i, demand, remains, digit, me;

i = 1;

/* First get demand */
demand=0;
remains=0;
digit=0;

remains=code-(SMAX+1)*wmax;
while (remains>=0)
{   demand++;
    code=remains;
    remains=remains-(SMAX+1)*wmax; }

/* Second, Get my state */
me=0;
remains=code-wmax;
while (remains>=0)
{   me=me+1;
    code=remains;
    remains=remains-wmax; }

/* Third: Rest of the State */
for (i=0;i<RLNFIRMS;i++)
{
    digit=0;
    while (binom[(RLNFIRMS+SMAX+1)*(digit+RLNFIRMS-i)+digit+1] <= code)
    {
          digit++;
          }

    ntuple[i]=digit;
    code = code-binom[(RLNFIRMS+SMAX+1)*(digit+RLNFIRMS-i-1)+digit];
 }

/* Return the market vector */
for (i=0;i<RLNFIRMS;i++)
	market->tuple[i]=ntuple[i];

market->demand=demand;
market->me=me;

}
/*-------------------------------------------------------------------------------*/
int encode(struct market_t * market,int binom[],int wmax,int ntuple[])
{
  int i,out,digit;
  int code=0;

  int me, demand;
  for (i=0;i<RLNFIRMS;i++)
    ntuple[i]=market->tuple[i];

  me=market->me;
  demand=market->demand;

code=0;

/* Sort the ntuple left over */
bubblesort2(ntuple);

for (i=0; i<RLNFIRMS; i++) {
 digit=ntuple[i];
 code = code +  binom[(digit+RLNFIRMS-i-1)*(RLNFIRMS+SMAX+1)+digit];
}
code=demand*(SMAX+1)*wmax+me*wmax+code;

return code;
}
/*-------------------------------------------------------------------------------*/
/* Bubble Sort Algorithm */
void bubblesort2(int * x) {
    int exchanges, i, temp;
    do {
       exchanges = 0;  // assume no exchanges
       for (i=0; i<RLNFIRMS-1; i++) {
          if (x[i] < x[i+1]) {
             temp = x[i];
             x[i] = x[i+1];
             x[i+1] = temp;
             exchanges = 1;  // after exchange, must look again
          }
       }
    } while (exchanges==1);
 }
/*-------------------------------------------------------------------------------*/
int drawerconda(int state, int a, int binom[],double CUMPTRANZ[],double CUMDTRANZ[],int wmax, struct market_t * market,struct market_t * marketprime,struct market_t * marketother,int ntuple[])
{
    /* Draw a state tommorow given the state today given the state to
state Transition's P and I take action a*/
int m, me, meprime, demand, i,j, otherstate, stateprime;
double u;

/* Decode the state */
decode(market,state,binom,wmax,ntuple);

/* Draw actions */
for (i=0; i<RLNFIRMS; i++)
	{
	/* Figure out who you are */
	marketother->me=market->me;
	marketother->demand=market->demand;
	for (j=0; j<RLNFIRMS; j++)
			marketother->tuple[j]=market->tuple[j];

	me=marketother->me;
	marketother->me=marketother->tuple[i];
	marketother->tuple[i]=me;
	otherstate=encode(marketother,binom,wmax,ntuple);

	/* Draw an action from P */
	u=(double) rand ()/(RAND_MAX + 1.00);
    for (j=0;(CUMPTRANZ[otherstate*(AMAX+1)+j]<u);j++);
	marketprime->tuple[i]=linkfunction(j,marketother->me);
}

/* Where do I go: just my action */
marketprime->me=linkfunction(a,market->me);

/* Demand Draw */
u=(double) rand ()/(RAND_MAX + 1.00);

for (j=0;(CUMDTRANZ[market->demand*(MAXDEMAND+1)+j]<u);j++);

marketprime->demand=j;

/* Encode the new state */
stateprime=encode(marketprime,binom,wmax,ntuple);
return stateprime;
}

/*-------------------------------------------------------------------------------*/
void cumtranzer(double CUMTRANZ[],const double TRANZ[],int maxI, int maxJ)
{
int i,j;
double sum;
sum=0.0;
/* Generates cumulative probabilities on a matrix */

for (i=0; i<maxI; i++) {
    sum=0.0;
    for (j=0; j<maxJ; j++)
	sum = sum + TRANZ[i*maxJ+j];

    CUMTRANZ[i*maxJ]=TRANZ[i*maxJ]/sum;
    for (j=1; j<maxJ; j++)
	CUMTRANZ[i*maxJ+j]=CUMTRANZ[i*maxJ+j-1]+TRANZ[i*maxJ+j]/sum;
	}
}
/*-------------------------------------------------------------------------------*/
void cumtranzeri(double CUMTRANZ[],double TRANZ[],int i, int maxJ)
{
int j;
double sum;
sum=0.0;
/* Generates cumulative probabilities on a vector */
for (j=0; j<maxJ; j++)
sum = sum + TRANZ[i*maxJ+j];

CUMTRANZ[i*maxJ]=TRANZ[i*maxJ]/sum;
for (j=1; j<maxJ; j++)
	CUMTRANZ[i*maxJ+j]=CUMTRANZ[i*maxJ+j-1]+TRANZ[i*maxJ+j]/sum;

}
/*-------------------------------------------------------------------------------*/
void choiceprobabilitiesNP(double theta[],double P[],double GMA[],int i, int wmax2)
{
/* Get Choice Probabilities for logit */
int j,t, flag=0;
double sum, Q;
sum=0.0;
/* Get the choice probabilities given payoffs */
for (j=0;j<=AMAX; j++) {
	Q=0.0;
	for (t=0;t<(THETADIM+1);t++)
		Q=Q+theta[t]*GMA[t*(AMAX+1)*wmax2+i*(AMAX+1)+j];

	flag=flag+(Q>350);
	sum = sum + exp(Q);
	}

for (j=0;j<=AMAX; j++) {
	Q=0.0;
	for (t=0;t<(THETADIM+1);t++)
		Q=Q+theta[t]*GMA[t*(AMAX+1)*wmax2+i*(AMAX+1)+j];

	/* Update Choice Probabilities  using Logit Formula */
	P[i*(AMAX+1)+j] =exp(Q)/sum;
	}

/* Sometimes exp(350) or so gets too big to compute
To fix this we can take the highest value or substract
the largest number
*/



if (flag>0){
	double themax=-100000000000.0;
	int j1;
	for (j=0;j<=AMAX; j++) {
	Q=0.0;
	for (t=0;t<(THETADIM+1);t++)
		Q=Q+theta[t]*GMA[t*(AMAX+1)*wmax2+i*(AMAX+1)+j];

	if(Q>themax) {
		themax=Q;
		for (j1=0;j1<=AMAX; j1++)
			P[i*(AMAX+1)+j1] =(double)(j1==j);
		}
	}
}


}
/*-------------------------------------------------------------------------------*/

void choiceprobabilities(double theta[],double P[],double QMA[],int i, int wmax2)
{
/* Get Choice Probabilities for logit */
int j,t, flag=0;
double sum, Q;
sum=0.0;
/* Get the choice probabilities given payoffs */
for (j=0;j<=AMAX; j++) {
	Q=QMA[i*(AMAX+1)+j];

	flag=flag+(Q>350);
	sum = sum + exp(Q);
	}

for (j=0;j<=AMAX; j++) {
	Q=QMA[i*(AMAX+1)+j];
	
	/* Update Choice Probabilities  using Logit Formula */
	P[i*(AMAX+1)+j] =exp(Q)/sum;
	}

/* Sometimes exp(350) or so gets too big to compute
To fix this we can take the highest value or substract
the largest number
*/



if (flag>0){
	double themax=-100000000000.0;
	int j1;
	for (j=0;j<=AMAX; j++) {
	Q=QMA[i*(AMAX+1)+j];
	
	if(Q>themax) {
		themax=Q;
		for (j1=0;j1<=AMAX; j1++)
			P[i*(AMAX+1)+j1] =(double)(j1==j);
		}
	}
}


}

/*-------------------------------------------------------------------------------*/

void buildbinom(int binom [], int * wmax, int * wmax2)
     {
/* Build the Binomial Matrix for decoding states */
int i, j;

     for (i=0; i<(RLNFIRMS+SMAX+1);i++) {
        for (j=0; j<(RLNFIRMS+SMAX+2);j++) {
               binom[i*(RLNFIRMS+SMAX+1)+j]=( (int)(i+1==j) );
               }
        }

    for (i=1; i<(RLNFIRMS+SMAX+1); i++) {
        for (j=1; j<(RLNFIRMS+SMAX+2);j++) {
                binom[i*(RLNFIRMS+SMAX+1)+j]=binom[(i-1)*(RLNFIRMS+SMAX+1)+j]
                +binom[(i-1)*(RLNFIRMS+SMAX+1)+j-1];
            }
         }

     *wmax = binom[(RLNFIRMS-1+1+SMAX)*(RLNFIRMS+SMAX+1)+SMAX+1];

     int ntuple[RLNFIRMS];
     struct market_t themarket;
     struct market_t * market=&themarket;

     for (i=0;i<RLNFIRMS; i++)
           market->tuple[i]=SMAX;

      market->me=SMAX;
      market->demand=MAXDEMAND;

      *wmax2=encode(market,binom,*wmax,ntuple)+1;
}



/*-------------------------------------------------------------------------------*/
int BRStochastic(double theta[],double GMA[],double P[], double D[],double DemandLevels[],double hits[],double rhits[],double * thedistance,struct SolutionParams_t * solsparms, int seed)
{
	/* Build Standard Things */
	int * binom=malloc(sizeof(int)*(RLNFIRMS+SMAX+1)*(RLNFIRMS+SMAX+2));

	int i,k,j,t;
	int r, algorithm;
	double q, sum;

	double Qsquig, Qsq2, Test, Variance, Bias;
	double totalhits;

	r=0;
	srand ( seed);

    /* Build the Binomial Matrix */
    int  wmax, wmax2, state;
    buildbinom(binom,&wmax,&wmax2);

	/* Set up state space */
	int loc, locprime, l, a, aprime, round;
	double theshock, alpha, u, distance, h;

    int ntuple[RLNFIRMS];
    struct market_t themarket;
    struct market_t * market=&themarket;
    struct market_t themarketprime;
    struct market_t * marketprime=&themarketprime;
    struct market_t themarketother;
    struct market_t * marketother=&themarketother;
    struct market_t themarkettoday;
    struct market_t * markettoday=&themarkettoday;
    struct market_t themarketyesterday;
    struct market_t * marketyesterday=&themarketyesterday;
    struct pcomp_t thepcomps;
    struct pcomp_t * pcomps=&thepcomps;

if (solsparms->noisy>0.99)
	printf("WMAX %5i and wmax2 %5i \n",wmax,wmax2);
double theKSIMS=(double) solsparms->ksims;
int MAXITERS=(int) solsparms->maxiter;
int MAXROUNDS=(int) solsparms->maxround;
int simulatedata=solsparms->simulatedata;
int thetadimension=(int) solsparms->thetadim;
int KSIMS=(int) solsparms->ksims;
int bestresponse=(int) solsparms->brfs;
if (solsparms->noisy>0.99)
	printf("Maxiter %5i and Maxround %5i \n",MAXITERS,MAXROUNDS);

/* Make Cumulative Transitions */
double * CUMPTRANZ=malloc(sizeof(double)*wmax2*(AMAX+1));
if (  CUMPTRANZ == NULL){
	return 31;
}
cumtranzer(CUMPTRANZ,P,wmax2,(AMAX+1));

double * CUMDTRANZ=malloc(sizeof(double)*(MAXDEMAND+1)*(MAXDEMAND+1));
if ( CUMDTRANZ == NULL){
	return 32;
}
cumtranzer(CUMDTRANZ,D,MAXDEMAND+1,MAXDEMAND+1);

for (i=0;i<wmax2*(AMAX+1);i++)
	rhits[i]=0.0;


/* Get Value */
/* Stochastic Algorithm where I just get the best response*/
double averageQ, oldaQ, Qpos;
int tothits;

oldaQ=0.0;
averageQ=0.0;
Test=100.0;

/* Initial State */
loc=1;
a=1;

double theprofit[THETADIM+1];
double thefuturevalue[THETADIM+1];

int m, j1;

printf("Technique %5f \n", solsparms->technique);
if (solsparms->technique>0.99) 
	printf("Start me up with Stationary Approximation \n");

/* Initialize GMA Step with Stationary Values */
if (solsparms->technique>0.99)
for (i=0;i<wmax2;i++) 
	for (j=1;j<(AMAX+1);j++) {
	loc=i;
	a=j;

	/* Set GMA to 0 */
	for (t=0;t<(THETADIM+1);t++)
	GMA[t*(AMAX+1)*wmax2+loc*(AMAX+1)+a]=0.0;

	for (k=0;k<10;k++) {
	locprime=drawerconda(loc,a,binom,CUMPTRANZ,CUMDTRANZ,wmax,market,marketprime,marketother,ntuple);
	
	/* Figure out payoff from this action*/
	profitNP(theprofit,theta,locprime,loc,binom,wmax,markettoday,marketyesterday,pcomps,ntuple,DemandLevels);

	/* Get the expected shock value */
	theshock=eulerc;

    	for(j1=0;j1<=AMAX;j1++) {
		h=P[locprime*(AMAX+1)+j1];
		theshock=theshock-log(h+DUST)*h;}
		

	/* update V and location with 1/(1-beta) scaling*/
	for (t=0;t<THETADIM;t++)
	GMA[t*(AMAX+1)*wmax2+loc*(AMAX+1)+a]=GMA[t*(AMAX+1)*wmax2+loc*(AMAX+1)+a]+theprofit[t]/(1-beta);

	/* Shock too */
	GMA[THETADIM*(AMAX+1)*wmax2+loc*(AMAX+1)+a]=GMA[THETADIM*(AMAX+1)*wmax2+loc*(AMAX+1)+a]+beta*theshock/(1-beta); 
	}

	/* Now to divide by number of k draws */
	for (t=0;t<(THETADIM+1);t++)
	GMA[t*(AMAX+1)*wmax2+loc*(AMAX+1)+a]=GMA[t*(AMAX+1)*wmax2+loc*(AMAX+1)+a]/10.0;

}
	




while (Test>TESTOL) {
for (round=0;round<MAXROUNDS;round++) {

for (k=0;k<MAXITERS;k++) {
	/* Draw a state tommorow */
	locprime=drawerconda(loc,a,binom,CUMPTRANZ,CUMDTRANZ,wmax,market,marketprime,marketother,ntuple);
	
	/* Figure out payoff from this action*/
	profitNP(theprofit,theta,locprime,loc,binom,wmax,markettoday,marketyesterday,pcomps,ntuple,DemandLevels);
	
	for(t=0;t<(THETADIM+1);t++) {
		thefuturevalue[t]=0.0;
			/* Get tommorows value */
			for(j=0;j<=AMAX;j++)
			thefuturevalue[t]=thefuturevalue[t]+GMA[t*(AMAX+1)*wmax2+locprime*(AMAX+1)+j]*P[locprime*(AMAX+1)+j];
	    }

		/* Get the expected shock value */
		theshock=eulerc;

	    for(j=0;j<=AMAX;j++) {
			h=P[locprime*(AMAX+1)+j];
			theshock=theshock-log(h+DUST)*h;}
		

		/* Update visits */
		hits[loc*(AMAX+1)+a]=hits[loc*(AMAX+1)+a]+1.0;
		rhits[loc*(AMAX+1)+a]=rhits[loc*(AMAX+1)+a]+1.0;

		alpha=hits[loc*(AMAX+1)+a];
		if (solsparms->alpharule==1.0)
			alpha=1.0/sqrt(alpha);
		if (solsparms->alpharule==2.0)
			alpha=1.0/alpha;

		/* update V and location*/
		for (t=0;t<THETADIM;t++)
		GMA[t*(AMAX+1)*wmax2+loc*(AMAX+1)+a]=GMA[t*(AMAX+1)*wmax2+loc*(AMAX+1)+a]*(1.00-alpha)+(theprofit[t]+beta*thefuturevalue[t])*alpha;
		

		/* Shock too */
		GMA[THETADIM*(AMAX+1)*wmax2+loc*(AMAX+1)+a]=GMA[THETADIM*(AMAX+1)*wmax2+loc*(AMAX+1)+a]*(1.00-alpha)+alpha*(beta*theshock+beta*thefuturevalue[THETADIM]);

		/* If you exit, you get nothing (Normalization) but you get the shock NOTE!*/
		if (a==0) 
			for (t=0;t<(THETADIM+1);t++) 
				GMA[t*(AMAX+1)*wmax2+loc*(AMAX+1)+a]=0;
			
			
		// Update Choices 
		if (bestresponse==1) {
			choiceprobabilitiesNP(theta,P,GMA,loc,wmax2);
			cumtranzeri(CUMPTRANZ,P,loc,(AMAX+1));
		}

		/* Update Start State */
		loc=locprime;
	    /* Draw an action tommorow */
		u=(double) rand ()/(RAND_MAX + 1.00);
		for (j=0;(CUMPTRANZ[locprime*(AMAX+1)+j]<u);j++);
		a=j;

		// Every so often just throw the state somewhere else in the state space (avoid getting trapped in a small reccurent state
		if ((((k/500)==0)&&(round<(MAXROUNDS-2)))) { 
			u=(double) rand ()/(RAND_MAX + 1.00);
			loc=(int)(u*(double) wmax2);
			u=(double) rand ()/(RAND_MAX + 1.00);
			a=(int)(u*(double) AMAX);
			}
	}
	if (solsparms->noisy>0.99)
	printf("Round %5i \n",round);

double todayprofit=0.0;
for (t=0;t<THETADIM;t++) {
	//todayprofit=todayprofit+theta[t]*theprofit[t];}
	
	todayprofit=todayprofit+theta[t]*(theprofit[t]+beta*thefuturevalue[t]);}
	
	todayprofit=todayprofit+(beta*theshock+beta*thefuturevalue[THETADIM]);
	//+beta*thefuturevalue[THETADIM]);
	//todayprofit=todayprofit+theta[t]*beta*thefuturevalue[t];




		
if (solsparms->noisy>0.99)
printf("Q %5f in state %5i and action %5i and Hits %5f \n", todayprofit,loc,a,hits[loc*(AMAX+1)+a]);
int pos,js,ergodicstates;
double thefv,theprof, Diff, xsum, ysum, xsq, ysq, xysum,xsum1, ysum1, xsq1, ysq1, xycross, top, sx, sy, n, correlation, correlation1;

/* Switch to bypass test*/
if (solsparms->test<0.99)
	Test=-1.0;


if ((round==(MAXROUNDS-1))&&(solsparms->test>0.99)) {
/* Pakes-Fershmann Stopping Criteria */
	/* Forward simulation for states that are recurrent */
	Test=0.0;
	Diff=0.0;
	totalhits=0;
	ergodicstates=0;
	xsum=0.0;
	ysum=0.0;
	xsq=0.0;
	ysq=0.0;
	xysum=0.0;
	xsum1=0.0;
	ysum1=0.0;
	xsq1=0.0;
	ysq1=0.0;
	xycross=0.0;
	theprof=0.0;

	for (i=0;i<wmax2;i++) {
		for (js=1;js<(AMAX+1);js++) /* Omit Action 0 states */{

		pos=i*(AMAX+1)+js;
		/* Only States that are recurrent */
		if (rhits[pos]>1) {
			Qsquig=0.0;
			Qsq2=0.0;
			Qpos=0.0;
			ergodicstates++;
			/* Value from Q function */
			for (t=0;t<(THETADIM+1);t++)
				Qpos=Qpos+theta[t]*GMA[t*(AMAX+1)*wmax2+i*(AMAX+1)+js];

			for (k=0;k<KSIMS;k++) {
			/* Draw states */
			locprime=drawerconda(i,js,binom,CUMPTRANZ,CUMDTRANZ,wmax,market,marketprime,marketother,ntuple);

			/* Figure out payoff from this action*/
			/* Get the profitNP */
			profitNP(theprofit,theta,locprime,i,binom,wmax,market,marketprime,pcomps,ntuple,DemandLevels);
			theprof=0.0;
			for (t=0;t<THETADIM;t++)
				theprof=theprof+theta[t]*theprofit[t];

			/* Get the expected shock value */
			theshock=eulerc;

	    		for(j=0;j<=AMAX;j++) {
				h=P[locprime*(AMAX+1)+j];
				theshock=theshock-log(h+DUST)*h;}
		
			
			thefv=0.0;

			/* Get tommorows value */
			for(j=0;j<(AMAX+1);j++)
				for (t=0;t<(THETADIM+1);t++)
					thefv=thefv+theta[t]*GMA[t*(AMAX+1)*wmax2+locprime*(AMAX+1)+j]*P[locprime*(AMAX+1)+j];

			Qsquig=Qsquig+(theprof+beta*thefv+beta*theshock);
			Qsq2=Qsq2+(theprof+beta*thefv+beta*theshock-Qpos)*(theprof+beta*thefv+beta*theshock-Qpos);
			/* Stuff for sample correlation */
			ysq=ysq+Qpos*Qpos/theKSIMS;
			ysum=ysum+Qpos/theKSIMS;

			xsq=xsq+(theprof+beta*thefv+beta*theshock)*(theprof+beta*thefv+beta*theshock)/theKSIMS;
			xsum=xsum+(theprof+beta*thefv+beta*theshock)/theKSIMS;

			xysum=xysum+Qpos*(theprof+beta*thefv+beta*theshock)/theKSIMS;
			}

			Qsquig=Qsquig/theKSIMS;
			/*printf(" State %5i Action %5i Hits %5f Qsquig %5f Qpos %5f \n",i,js,rhits[pos],Qsquig,Qpos);*/
			Qsq2=Qsq2/(theKSIMS-1);

			xsum1=xsum1+Qpos*(rhits[pos]);
			ysum1=ysum1+Qsquig*(rhits[pos]);
			xsq1=xsq1+Qpos*Qpos*(rhits[pos]);
			ysq1=ysq1+Qsquig*Qsquig*(rhits[pos]);
			xycross=xycross+Qpos*Qsquig*(rhits[pos]);

			Diff=Diff+fabs(Qpos-Qsquig)*(rhits[pos]);
			Bias=((Qpos-Qsquig)*(Qpos-Qsquig)-Qsq2)/(Qpos*Qpos);

			Test=Test+Bias*(rhits[pos]);
			totalhits=totalhits+rhits[pos];
		}
		}
	}
if (solsparms->noisy>0.99) {
	/* Correlation */
	n=(double) ergodicstates;
	top=(n*xysum-xsum*ysum);
	sx=sqrt(n*xsq-xsum*xsum);
	sy=sqrt(n*ysq-ysum*ysum);
	correlation=top/(sx*sy);

	top=(xycross-xsum1*ysum1/totalhits);
	sx=sqrt(xsq1-xsum1*xsum1/totalhits);
	sy=sqrt(ysq1-ysum1*ysum1/totalhits);

	correlation1=top/(sx*sy);


	printf("Mean Qsquig %5f Mean Qpos %5f  \n",ysum1/totalhits,xsum1/totalhits);
	printf("Total Hits %3f ",totalhits);}
	printf("Difference %3f \n",Diff/totalhits);
	printf("Correlation %3f \n",correlation);
	printf("Correlation Accross Sims %3f \n",correlation1);
	printf("Number of Ergodic States %3i \n",ergodicstates);
	/* Test Statistic */
    Test=Test/((double) totalhits);
    Test=-100*(correlation1>0.99);
if (solsparms->noisy>0.99)
	printf(" Test %5f \n",Test);

    }

/* Reset Recent Hits */
if( round<(MAXROUNDS-1)){
  for (i=0;i<wmax2*(AMAX+1);i++)
           rhits[i]=0.0; }

}
}


/* Allocation Time */
*thedistance=Test;


/* Free Stuff you've used */
free(binom);
free(CUMPTRANZ);
free(CUMDTRANZ);

if (solsparms->noisy>0.99)
	printf("Done with this call \n");

return 10;
}

/*-------------------------------------------------------------------------------*/
int ForwardSimulation(double theta[],double GMA[],double P[], double D[],double DemandLevels[],double parmvector[],double *seed)
{
/* Estimates the Pre-Multiplied Value Function by Forward Simulation */

/* Decode Parameters */
struct SolutionParams_t thesolsparms;
struct SolutionParams_t * solsparms=&thesolsparms;
decodeparms(solsparms,parmvector);
int seeder;
double seedhold;
seedhold=*seed;
seeder=(int) (seedhold);

/* Build Standard Things */
int * binom=malloc(sizeof(int)*(RLNFIRMS+SMAX+1)*(RLNFIRMS+SMAX+2));
int i,k,j,t;
int r, algorithm;
double q, sum;
r=0;
srand (seeder);
/* Build the Binomial Matrix */
int  wmax, wmax2, state;
buildbinom(binom,&wmax,&wmax2);

/* Set up state space */
int loc, locprime, l, a, aprime, round;
double theshock, alpha, u, distance, h;

int ntuple[RLNFIRMS];
struct market_t themarket;
struct market_t * market=&themarket;
struct market_t themarketprime;
struct market_t * marketprime=&themarketprime;
struct market_t themarketother;
struct market_t * marketother=&themarketother;
struct market_t themarkettoday;
struct market_t * markettoday=&themarkettoday;
struct market_t themarketyesterday;
struct market_t * marketyesterday=&themarketyesterday;
struct pcomp_t thepcomps;
struct pcomp_t * pcomps=&thepcomps;

if (solsparms->noisy>0.99)
	printf("WMAX %5i and wmax2 %5i \n",wmax,wmax2);
double theKSIMS=(double) solsparms->ksims;
int MAXITERS=(int) solsparms->maxiter;
int MAXROUNDS=(int) solsparms->maxround;
int simulatedata=solsparms->simulatedata;
int thetadimension=(int) solsparms->thetadim;
int KSIMS=(int) solsparms->ksims;
int bestresponse=(int) solsparms->brfs;
if (solsparms->noisy>0.99)
	printf("Maxiter %5i and Maxround %5i \n",MAXITERS,MAXROUNDS);

/* Make Cumulative Transitions */
double * CUMPTRANZ=malloc(sizeof(double)*wmax2*(AMAX+1));
if (  CUMPTRANZ == NULL){
	return 31;
}
cumtranzer(CUMPTRANZ,P,wmax2,(AMAX+1));

double * CUMDTRANZ=malloc(sizeof(double)*(MAXDEMAND+1)*(MAXDEMAND+1));
if ( CUMDTRANZ == NULL){
	return 32;
}
cumtranzer(CUMDTRANZ,D,MAXDEMAND+1,MAXDEMAND+1);


/* Get Value */
double theprofit[THETADIM+1];
double thefuturevalue[THETADIM+1];

int m, j1;
double tau;
int locstart, astart;

int nthreads;

nthreads=omp_get_thread_num();
printf(" We have %i Threads \n",nthreads);

#pragma omp parallel for 

for (i=0;i<wmax2;i++){
	for (j=1;j<(AMAX+1);j++) {

	/* Set GMA to 0 */
	for (t=0;t<(THETADIM+1);t++)
	GMA[t*(AMAX+1)*wmax2+i*(AMAX+1)+j]=0.0;

	// 100 Simulations 
	for (k=0;k<100;k++) {
		/* Start Point */
		loc=i;
		a=j;
	
		// Up to 100 periods in the future
		for (tau=0.0;(tau<100.0)&(a>0);tau++) {
		locprime=drawerconda(loc,a,binom,CUMPTRANZ,CUMDTRANZ,wmax,market,marketprime,marketother,ntuple);
	
		/* Figure out payoff from this action*/
		profitNP(theprofit,theta,locprime,loc,binom,wmax,markettoday,marketyesterday,pcomps,ntuple,DemandLevels);

		/* Get the expected shock value */
		theshock=eulerc;

    		for(j1=0;j1<=AMAX;j1++) {
			h=P[locprime*(AMAX+1)+j1];
			theshock=theshock-log(h+DUST)*h;}
		
		/* update GMA*/
		for (t=0;t<THETADIM;t++)
			GMA[t*(AMAX+1)*wmax2+i*(AMAX+1)+j]+=pow(beta,tau)*theprofit[t];

		/* Shock too */
		GMA[THETADIM*(AMAX+1)*wmax2+i*(AMAX+1)+j]+=pow(beta,tau)*beta*theshock;


//		printf("Location %i Action %i Period %f \n",loc,a,tau);

		/* Update Location */
		loc=locprime;
		
		/* Draw an action from P */
		u=(double) rand ()/(RAND_MAX + 1.00);
    		for (a=0;(CUMPTRANZ[loc*(AMAX+1)+a]<u);a++);
		
		}
		
	}

	/* Now to divide by number of k draws */
	for (t=0;t<(THETADIM+1);t++)
		GMA[t*(AMAX+1)*wmax2+i*(AMAX+1)+j]=GMA[t*(AMAX+1)*wmax2+i*(AMAX+1)+j]/100.0;

	}
	/* Action 0 is 0 */
	for (t=0;t<(THETADIM+1);t++) 
		GMA[t*(AMAX+1)*wmax2+i*(AMAX+1)+0]=0.0;

	/* Output */
	if ((i%10000)==0)
		printf("In Location %i \n", i);
}	

/* Free Stuff you've used 
free(binom);
free(CUMPTRANZ);
free(CUMDTRANZ);*/

return 10;
}


/*-------------------------------------------------------------------------------*/
void descriptor(int a,int state,int desmat[], int binom[], int wmax,struct market_t * market, int ntuple[])
{
int k, i, comps;


/* Decode the State */
decode(market,state,binom,wmax,ntuple);
desmat[0]=a;
desmat[1]=market->me;
desmat[2]=market->demand;

comps=0;
/* Return the market vector */
for (i=0;i<RLNFIRMS;i++)
	comps=comps+(market->tuple[i]>0);

	desmat[3]=comps;
}
/*-------------------------------------------------------------------------------*/
void descriptor2(int state,int desmat[], int binom[], int wmax,struct market_t * market, int ntuple[])
{
int k, i, comps;

/* Decode the State */
decode(market,state,binom,wmax,ntuple);

desmat[0]=1;

for (i=1;i<(SMAX+1);i++)
	desmat[i]=(market->me==i); // Indicator for me

desmat[SMAX+1]=market->demand;
comps=0;

/* Return the market vector */
for (i=0;i<RLNFIRMS;i++)
	comps=comps+(market->tuple[i]>0);


//desmat[SMAX+2]=comps;
desmat[SMAX+2]=(comps>0);
desmat[SMAX+3]=(comps>1);
desmat[SMAX+4]=(comps>2);
desmat[SMAX+5]=comps;

}

/*-------------------------------------------------------------------------------*/
int logitpredict(double theta[],double P[],double DemandLevels[], double parmvector[])
{
struct SolutionParams_t thesolsparms;
struct SolutionParams_t * solsparms=&thesolsparms;
decodeparms(solsparms,parmvector);
int wmax2,wmax;
	
wmax2=(int) solsparms->wmax2;
wmax=(int) solsparms->wmax;

/* Build Standard Things */
int * binom=malloc(sizeof(int)*(RLNFIRMS+SMAX+1)*(RLNFIRMS+SMAX+2));
buildbinom(binom,&wmax,&wmax2);

int ntuple[RLNFIRMS];
struct market_t themarkets;
struct market_t * markets=&themarkets;

int i,j,t,
    desmat[100];
    
for (i=1;i<100;i++)
	desmat[i]=0;

double sum,insum, Q;

/* Vectorize this */
#pragma omp parallel for
for (i=0;i<wmax2;i++) {
	sum=0.0;
	descriptor2(i,desmat,binom,wmax,markets,ntuple);
	for (j=0;j<(AMAX+1);j++){
	insum=0.0;
	
	for (t=0;t<(SMAX+5);t++)
		insum=insum+((double)desmat[t])*theta[j*(SMAX+6)+t];
	
	if (desmat[t]>3)
	insum=insum+theta[j*(SMAX+6)+t]*log((double)desmat[t]+0.0)*((double)desmat[t]>3);

	
	// Demand
	insum=insum+(DemandLevels[desmat[SMAX+1]]-((double) desmat[SMAX+1]))*theta[j*(SMAX+6)+SMAX+1];
	
	
	sum=sum+exp(insum);
	}
	
	for (j=0;j<(AMAX+1);j++){
	Q=0.0;
	for (t=0;t<(SMAX+5);t++)
		Q=Q+((double)desmat[t])*theta[j*(SMAX+6)+t];
		
	if (desmat[t]>3)
		Q=Q+theta[j*(SMAX+6)+t]*log((double)desmat[t]+0.0)*((double)desmat[t]>3);
	
	// Demand
	Q=Q+(DemandLevels[desmat[SMAX+1]]-((double) desmat[SMAX+1]))*theta[j*(SMAX+6)+SMAX+1];
		
	
	P[i*(AMAX+1)+j]=exp(Q)/sum;
	}

}

}
/*------------------------------------------------------------------------------*/
double value_function(const double theta[],const double P[],const double Q[],int state, int wmax2)
{ 
/* Function Computes Producer Surplus given Q*/
int j, t;

double ps=0.0, h=0.0, theshock;

/* Get the expected shock value */
theshock=eulerc;

for(j=0;j<=AMAX;j++) {
	h=P[state*(AMAX+1)+j];
	theshock=theshock-log(h+DUST)*h;
        }

ps=theshock;

/* Non-Stochastic Component of Value Function */

for (j=0;j<=AMAX; j++) 
	ps=ps+Q[state*(AMAX+1)+j]*P[state*(AMAX+1)+j];


return ps;
}
/*-------------------------------------------------------------------------------*/
int SimulateData(const double theta[],const double Q[], const double P[],const double D[],const double hits[], double actiondata[],double statedata[], double markettype[],double mestate[],double demands[],double comp1[],double plantid[],double year[],double marketdata[],double * lengthdata, double ps[], double x[],const double parmvector[],const int seed)
{

struct SolutionParams_t thesolsparms;
struct SolutionParams_t * solsparms=&thesolsparms;
decodeparms(solsparms,parmvector);
int wmax2,wmax, i, j, t, state;
double u;

wmax2=(int) solsparms->wmax2;
wmax=(int) solsparms->wmax;

/* Set Seed to get similar runs */
srand(seed);

/* Build Standard Things */
int * binom=malloc(sizeof(int)*(RLNFIRMS+SMAX+1)*(RLNFIRMS+SMAX+2));
buildbinom(binom,&wmax,&wmax2);
	int ntuple[RLNFIRMS];
	struct market_t themarket;
    struct market_t * market=&themarket;
    struct market_t themarketprime;
    struct market_t * marketprime=&themarketprime;
    struct market_t themarketother;
    struct market_t * marketother=&themarketother;
    struct market_t themarkettoday;
    struct market_t * markettoday=&themarkettoday;
    struct market_t themarketyesterday;
    struct market_t * marketyesterday=&themarketyesterday;
    struct pcomp_t thepcomps;
    struct pcomp_t * pcomps=&thepcomps;


/* Make Cumulative Transitions */
double * CUMPTRANZ =malloc(sizeof(double)*wmax2*(AMAX+1));
cumtranzer(CUMPTRANZ,P,wmax2,(AMAX+1));
double * CUMDTRANZ=malloc(sizeof(double)*(MAXDEMAND+1)*(MAXDEMAND+1));
cumtranzer(CUMDTRANZ,D,MAXDEMAND+1,MAXDEMAND+1);

if (solsparms->noisy>0.99)
for (j=0;j<(AMAX+1);j++) {
	printf("The P %5f",P[j]);
	printf("The CP %5f",CUMPTRANZ[j]);
}
/* Simulate Data */
int SIMDATA=(int) solsparms->simulatedata;

int size_of_data=(int) solsparms->datasize;
printf("Simulating Data with %1f observations using technique %1i \n",solsparms->datasize,SIMDATA);

int desmat[100];
/* Just Random State Picked each time */
if (SIMDATA==1) {

for (t=0;t<size_of_data;t++) {
/* Draw a state uniform from [0,wmax2] */
state= (double)( rand () * (int) (solsparms->wmax2) /(RAND_MAX + 1.00));

/* Draw an action from P */
u=(double) rand ()/(RAND_MAX+1.00);
for (j=0;(CUMPTRANZ[state*(AMAX+1)+j]<u);j++);

/* Record the action and state */
actiondata[t]=(double) j;
statedata[t]=(double) state;
markettype[t]=(double) 1;

/* Descriptor Data */
descriptor(j,state,desmat,binom,wmax,market,ntuple);
mestate[t]=(double) desmat[1];
demands[t]=(double) desmat[2];
comp1[t]=(double) desmat[3];

	}

*lengthdata=(double) t;
printf(" Simulation Done Non-Panel \n");
}

/* Simulate the Data coming from a Panel of Markets */

if (SIMDATA==2) {
printf(" Simulation for Panel Starting \n");

int * x0=malloc(sizeof(int)*((int) solsparms->simmarketsnums)); /* Initial States*/

printf("Number of Market %5f \n",solsparms->simmarketsnums);

for (i=0;i<(int) solsparms->simmarketsnums;i++) 
	x0[i]=(int) x[i];


int counter=0;
int x, m, me, meprime, demand, otherstate, stateprime, inot;

/* Keep Track of Firm ID */
int idmat[RLNFIRMS+1];
int lastid=1;


double ps_inc=0.0;
double ps_ent=0.0;

int market_numbers;
market_numbers=(int) solsparms->simmarketsnums; 

for (m=0; m<market_numbers; m++) {

state=x0[m];

/* Fill up ID's */
for (i=0; i<(RLNFIRMS+1); i++, lastid++)
	idmat[i]=lastid;


decode(market,state,binom,wmax,ntuple);
	
/* Compute Surplus for Incumbents */
for (i=0; i<(RLNFIRMS+1); i++) {
	decode(market,state,binom,wmax,ntuple);
	/* Figure out who you are */
	marketother->me=market->me;
	marketother->demand=market->demand;
	for (j=0; j<RLNFIRMS; j++)
			marketother->tuple[j]=market->tuple[j];
	/* Other Firms */
	me=marketother->me;
	marketother->me=marketother->tuple[i];
	marketother->tuple[i]=me;

	otherstate=encode(marketother,binom,wmax,ntuple);

	ps_inc=ps_inc+value_function(theta,P,Q,otherstate,wmax2);}


// 
int actionholder[RLNFIRMS];


for (t=0;t<(solsparms->simtimeperiod);t++) {


/* Decode the state */
decode(market,state,binom,wmax,ntuple);


/* Draw actions */
for (i=0; i<RLNFIRMS; i++)
	{

	/* Fill in my state */
	marketother->demand=market->demand;
	for (inot=0; inot<RLNFIRMS; inot++)
		marketother->tuple[inot]=market->tuple[inot];

	/* Other Firms */
	marketother->me=market->tuple[i];
	marketother->tuple[i]=market->me;
	otherstate=encode(marketother,binom,wmax,ntuple);


	/* Producer Surplus for Entrants*/ 
	if (marketother->me==0)
		ps_ent=ps_ent+pow(beta,t)*value_function(theta,P,Q,state,wmax2);

	/* Draw an action from P */
	u=(double) rand ()/(RAND_MAX + 1.00);
   	for (j=0;(CUMPTRANZ[otherstate*(AMAX+1)+j]<u);j++);

	marketprime->tuple[i]=linkfunction(j,marketother->me);
	
	actionholder[i]=j;

	/* Record State and Action*/
	if ((counter<solsparms->datasize)) {
	actiondata[counter]=(double) j;
	statedata[counter]=(double) otherstate;
	markettype[counter]=(double) x;


	/* Descriptor Data */
	descriptor(j,otherstate,desmat,binom,wmax,marketother,ntuple);
	mestate[counter]=(double) desmat[1];
	demands[counter]=(double) desmat[2];
	comp1[counter]=(double) desmat[3];
	year[counter]=(double) t;
	marketdata[counter]=(double) m;
	/* ID Data */
	plantid[counter]=(double) idmat[i];
	if (j==0)
		{idmat[i]=lastid; lastid++;} /* Update ID if exit*/

	counter++;
	}

}

/* Where do I go: just my action */
u=(double) rand ()/(RAND_MAX + 1.00);
for (j=0;(CUMPTRANZ[state*(AMAX+1)+j]<u);j++);
marketprime->me=linkfunction(j,market->me);

/* Record Data*/
if ((counter<solsparms->datasize)) 
{
actiondata[counter]=(double) j;
statedata[counter]=(double) state;
markettype[counter]=(double) x;
/* Descriptor Data */
descriptor(j,state,desmat,binom,wmax,market,ntuple);
mestate[counter]=(double) desmat[1];
demands[counter]=(double) desmat[2];
comp1[counter]=(double) desmat[3];
year[counter]=(double) t;
marketdata[counter]=(double) m;

/* ID Data */
plantid[counter]=(double) idmat[RLNFIRMS];
if (j==0)
	{idmat[RLNFIRMS]=lastid; lastid++;} /* Update ID if exit*/

counter++;
}


/* Demand Draw */
u=(double) rand ()/(RAND_MAX + 1.00);
for (j=0;(CUMDTRANZ[market->demand*(MAXDEMAND+1)+j]<u);j++);
marketprime->demand=j;

/* Encode the new state */
stateprime=encode(marketprime,binom,wmax,ntuple);
state=stateprime;

		}
	}

*lengthdata=(double) counter;
ps[0]=ps_ent;
ps[1]=ps_inc;


printf("Producer Surplus for Entrant %5f, For Incumbents %5f \n",ps_ent,ps_inc);


printf("Panel Simulation Done \n");
free(x0);
}


free(binom);
free(CUMPTRANZ);
free(CUMDTRANZ);

return 1;
}



/*-------------------------------------------------------------------------------*/
int StochasticBR(double * theta,double * Q, double * P, double * D, double * DemandLevels, double *thehits, double *recenthits,double * thedistance, double * returncode,double * parmvector, double * seed)
{

/* Decode Parameters */
struct SolutionParams_t thesolsparms;
struct SolutionParams_t * solsparms=&thesolsparms;
decodeparms(solsparms,parmvector);
int seeder;
double seedhold;
seedhold=*seed;

seeder=(int) (seedhold);
if (solsparms->noisy>0.99)
printf("Hello \n");

*returncode=(double)BRStochastic(theta,Q,P,D,DemandLevels,thehits,recenthits,thedistance,solsparms,seeder);
if (solsparms->noisy>0.99)
printf("Goodbye \n");
return 1;
}
/*-------------------------------------------------------------------------------*/

int UpdateChoiceProbabilities(double theta[], double P[], double GMA[],double parmvector[])
{
	struct SolutionParams_t thesolsparms;
	struct SolutionParams_t * solsparms=&thesolsparms;
	decodeparms(solsparms,parmvector);
	int wmax2, i;
	wmax2=(int) solsparms->wmax2;
	for (i=0;i<wmax2;i++)
	choiceprobabilitiesNP(theta,P,GMA,i,wmax2);
	return 1;
}
/*-------------------------------------------------------------------------------*/
int CodeStates(double parmvector[],double statevec[],double *thestate)
{

struct SolutionParams_t thesolsparms;
struct SolutionParams_t * solsparms=&thesolsparms;
decodeparms(solsparms,parmvector);
int wmax2,wmax;

wmax2=(int) solsparms->wmax2;
wmax=(int) solsparms->wmax;

/* Build Standard Things */
int * binom=malloc(sizeof(int)*(RLNFIRMS+SMAX+1)*(RLNFIRMS+SMAX+2));
buildbinom(binom,&wmax,&wmax2);

int ntuple[RLNFIRMS];
struct market_t themarkets;
struct market_t * markets=&themarkets;

*thestate=(double) codestate(statevec,markets,ntuple,binom,wmax);

free(binom);
return 1;
}


int codestate(double statevec[],struct market_t * markets,int ntuple[RLNFIRMS], int binom[], int wmax) {
int i;

for (i=0;i<RLNFIRMS;i++)
	markets->tuple[i]=statevec[i];

markets->me=statevec[i]; i++;
markets->demand=statevec[i];

return encode(markets,binom,wmax,ntuple);
}
/*-------------------------------------------------------------------------------*/
int Descriptor(double actiondata[], double statedata[],double mestate[],double demands[], double comp1[], double parmvector[],double markettype[], double DemandLevels[]) 
{
struct SolutionParams_t thesolsparms;
struct SolutionParams_t * solsparms=&thesolsparms;
decodeparms(solsparms,parmvector);
int wmax2,wmax,t;

wmax2=(int) solsparms->wmax2;
wmax=(int) solsparms->wmax;

/* Build Standard Things */
int * binom=malloc(sizeof(int)*(RLNFIRMS+SMAX+1)*(RLNFIRMS+SMAX+2));
buildbinom(binom,&wmax,&wmax2);

int ntuple[RLNFIRMS];
struct market_t themarkets;
struct market_t * markets=&themarkets;

int mtype;
int desmat[100];
printf("I am describing the State");
int datasize;
datasize=(int) solsparms->datasize;
printf("of  %5i observations",datasize);
for (t=0;t<(datasize);t++) {
/* Descriptor Data */
descriptor((int) actiondata[t],(int) statedata[t],desmat,binom,wmax,markets,ntuple);

mtype=(int) markettype[t];
mestate[t]=(double) desmat[1];
demands[t]=DemandLevels[(mtype-1)*MAXDEMAND+desmat[2]];
comp1[t]=(double) desmat[3];
}
printf(". \n");
}


/*-------------------------------------------------------------------------------*/

int simdata(double theta[], double statedata[],double markettype[],double GMA[],double * mtype,double parmvector[], double predictedaction[])
{
/* Build Standard Things */
int * binom=malloc(sizeof(int)*(RLNFIRMS+SMAX+1)*(RLNFIRMS+SMAX+2));

/* Build the Binomial Matrix */
int  wmax, wmax2;
buildbinom(binom,&wmax,&wmax2);

struct SolutionParams_t thesolsparms;
struct SolutionParams_t * solsparms=&thesolsparms;
decodeparms(solsparms,parmvector);

int SizeData;
double newtheta[(int) solsparms->thetadim];
SizeData = (int) solsparms->datasize-10;

int ntuple[RLNFIRMS];
struct market_t themarket;
struct market_t * market=&themarket;

int i,j, m,z;
double Q, sum, CP[AMAX+1], CUMCP[AMAX+1], u;
int state, marketp, x, t, flag, counter;	

srand(123);
z=0;

for (x=0;x<SizeData;x++) {
	marketp=(int) (markettype[x]-1);
	if (markettype[x]==*mtype){
	state=(int) statedata[x];
	/* Decode the State */
	decode(market,state,binom,wmax,ntuple);
	
	/* Get Choice Probabilities for logit */
	sum=0.0;
	
	/* Get the choice probabilities given payoffs */
	for (j=0;j<=AMAX; j++) {
		Q=0.0;
		for (t=0;t<(THETADIM+1);t++)
			Q=Q+theta[t]*GMA[marketp*(THETADIM+1)*wmax2*(AMAX+1)+t*(AMAX+1)*wmax2+state*(AMAX+1)+j];
		
		
		if (Q>300)
			flag=1;
			
		sum = sum + exp(Q);}

	for (j=0;j<=AMAX; j++) {
	Q=0.0;
	for (t=0;t<(THETADIM+1);t++)
		Q=Q+theta[t]*GMA[marketp*(THETADIM+1)*wmax2*(AMAX+1)+t*(AMAX+1)*wmax2+state*(AMAX+1)+j];
	
	CP[j]=exp(Q)/sum;
	}
	
	CUMCP[0]=CP[0];
	CUMCP[1]=CUMCP[0]+CP[1];
	CUMCP[2]=CUMCP[1]+CP[2];
	CUMCP[3]=CUMCP[2]+CP[3];
	
	// Draw an action
	u=(double) rand ()/(RAND_MAX + 1.00);
    	for (j=0;(CUMCP[j]<u);j++);
	predictedaction[x]=(double) j;	
	
	}
	}
	
 }

/*-------------------------------------------------------------------------------*/

int simdata2(double theta[], double statedata[],double markettype[],double GMA[],double * mtype,double parmvector[], double predictedaction[])
{
/* Build Standard Things */
int * binom=malloc(sizeof(int)*(RLNFIRMS+SMAX+1)*(RLNFIRMS+SMAX+2));

/* Build the Binomial Matrix */
int  wmax, wmax2;
buildbinom(binom,&wmax,&wmax2);

struct SolutionParams_t thesolsparms;
struct SolutionParams_t * solsparms=&thesolsparms;
decodeparms(solsparms,parmvector);

int SizeData;
double newtheta[(int) solsparms->thetadim];
SizeData = (int) solsparms->datasize-10;

int ntuple[RLNFIRMS];
struct market_t themarket;
struct market_t * market=&themarket;
    
int i,j, m;

double Q, sum, CP[AMAX+1], CUMCP[AMAX+1], u;
int state, marketp, x, t, flag, counter;	

srand(123);

int z=0;

for (x=0;x<SizeData;x++) {
	marketp=(int) (markettype[x]-1);
	if (markettype[x]==*mtype){
	state=(int) statedata[x];
	/* Decode the State */
	decode(market,state,binom,wmax,ntuple);
	
	/* Get Choice Probabilities for logit */
	sum=0.0;
	
	flag=0;
	
	/* Get the choice probabilities given payoffs */
	for (j=0;j<=AMAX; j++) {
		Q=0.0;
		for (t=0;t<(THETADIM+1);t++)
			Q=Q+theta[t]*GMA[marketp*(THETADIM+1)*wmax2*(AMAX+1)+t*(AMAX+1)*wmax2+state*(AMAX+1)+j];
		
		
		if (Q>350)
			flag=1;
		if (Q<350)
		sum = sum + exp(Q);}

	for (j=0;j<=AMAX; j++) {
	Q=0.0;
	for (t=0;t<(THETADIM+1);t++)
		Q=Q+theta[t]*GMA[marketp*(THETADIM+1)*wmax2*(AMAX+1)+t*(AMAX+1)*wmax2+state*(AMAX+1)+j];
	
	if (Q<350)
		CP[j]=exp(Q)/sum;
	if (Q>350)
		CP[j]=-2000.0;	

/*
	if (flag==1){
	double themax=-100000000000.0;
	int j1;
	for (j=0;j<=AMAX; j++) {
	Q=0.0;
	for (t=0;t<(THETADIM+1);t++)
		Q=Q+theta[t]*GMA[marketp*(THETADIM+1)*wmax2*(AMAX+1)+t*(AMAX+1)*wmax2+state*(AMAX+1)+j];

	if(Q>themax) {
		themax=Q;
		for (j1=0;j1<=AMAX; j1++)
			CP[i*(AMAX+1)+j1] =(double)(j1==j);
		}
	}
}*/

	}
	//predictedaction[z]=CP[0];
	predictedaction[z]=CP[1];
	predictedaction[z+1]=CP[2];
	predictedaction[z+2]=CP[3];
	}
	//z=z+4;
	z=z+3;
	}
	
 }

/*--------------------------------------------------------*/

int convert_GMA_to_data(double statedata[],double markettype[],double GMA[],double parmvector[], double GMAvec[])
{
/* Build Standard Things */
int * binom=malloc(sizeof(int)*(RLNFIRMS+SMAX+1)*(RLNFIRMS+SMAX+2));

/* Build the Binomial Matrix */
int  wmax, wmax2;
buildbinom(binom,&wmax,&wmax2);

struct SolutionParams_t thesolsparms;
struct SolutionParams_t * solsparms=&thesolsparms;
decodeparms(solsparms,parmvector);

int SizeData;
SizeData = (int) solsparms->datasize-2;

int ntuple[RLNFIRMS];
struct market_t themarket;
struct market_t * market=&themarket;

int i,j, m;

int state, marketp, x, t;	

srand(123);

for (x=0;x<SizeData;x++) {
	marketp=(int) (markettype[x]-1);
	state=(int) statedata[x];
	/* Decode the State */
	decode(market,state,binom,wmax,ntuple);
	
	/* Get GMA's*/
	for (j=0;j<=AMAX; j++) {
		GMAvec[x*(THETADIM+3)*(AMAX+1)+j*(THETADIM+3)+0]=(double) j;
		GMAvec[x*(THETADIM+3)*(AMAX+1)+j*(THETADIM+3)+1]=(double) marketp;
		for (t=0;t<(THETADIM+1);t++)
			GMAvec[x*(THETADIM+3)*(AMAX+1)+j*(THETADIM+3)+t+2]=GMA[marketp*(THETADIM+1)*wmax2*(AMAX+1)+t*(AMAX+1)*wmax2+state*(AMAX+1)+j];
		}
	
	
	}

 }


/*--------------------------------------------------------*/
int Value_Iteration_Simulation(double theta[],double QMA[],double P[], double D[],double DemandLevels[],double hits[],double rhits[],double * thedistance,struct SolutionParams_t * solsparms, int seed)
{
// Use Value Iteration and Simulation to do computation.
printf("Value Iteration via Simulation \n");

	/* Build Standard Things */
	int * binom=malloc(sizeof(int)*(RLNFIRMS+SMAX+1)*(RLNFIRMS+SMAX+2));

	int i,k,j,t;
	int r, algorithm;
	double q, sum;

	double Qsquig, Qsq2, Test, Variance, Bias;
	double totalhits;

	r=0;
	srand ( seed);

    /* Build the Binomial Matrix */
    int  wmax, wmax2, state;
    buildbinom(binom,&wmax,&wmax2);

	/* Set up state space */
	int loc, locprime, l, a, aprime, round;
	double theshock, alpha, u, distance, h;

    int ntuple[RLNFIRMS];
    struct market_t themarket;
    struct market_t * market=&themarket;
    struct market_t themarketprime;
    struct market_t * marketprime=&themarketprime;
    struct market_t themarketother;
    struct market_t * marketother=&themarketother;
    struct market_t themarkettoday;
    struct market_t * markettoday=&themarkettoday;
    struct market_t themarketyesterday;
    struct market_t * marketyesterday=&themarketyesterday;
    struct pcomp_t thepcomps;
    struct pcomp_t * pcomps=&thepcomps;

if (solsparms->noisy>0.99)
	printf("WMAX %5i and wmax2 %5i \n",wmax,wmax2);
double theKSIMS=(double) solsparms->ksims;
int MAXITERS=(int) solsparms->maxiter;
int MAXROUNDS=(int) solsparms->maxround;
int simulatedata=solsparms->simulatedata;
int thetadimension=(int) solsparms->thetadim;
int KSIMS=(int) solsparms->ksims;
double VALSIMS=solsparms->ksims;

int bestresponse=(int) solsparms->brfs;
if (solsparms->noisy>0.99)
	printf("Maxiter %5i and Maxround %5i \n",MAXITERS,MAXROUNDS);

/* Make Cumulative Transitions */
double * CUMPTRANZ=malloc(sizeof(double)*wmax2*(AMAX+1));
if (  CUMPTRANZ == NULL){
	return 31;
}
cumtranzer(CUMPTRANZ,P,wmax2,(AMAX+1));

double * CUMDTRANZ=malloc(sizeof(double)*(MAXDEMAND+1)*(MAXDEMAND+1));
if ( CUMDTRANZ == NULL){
	return 32;
}
cumtranzer(CUMDTRANZ,D,MAXDEMAND+1,MAXDEMAND+1);

for (i=0;i<wmax2*(AMAX+1);i++)
	rhits[i]=0.0;


/* Get Value */

double theprofit[THETADIM+1];
double thefuturevalue;
double profitvalue;

int m;


int iterval;
double valest, distval, totalval;
distval=100.0;

printf("Value Iteration via Simulation with %1f Simulations \n",VALSIMS);

/* Note 30 Minimum Distance Criteria */
for (iterval=0;((iterval<200)&(distval>60.0))|(iterval<MAXITERS);iterval++){
	distval=0.0; totalval=0.0;
	
	for (loc=0;loc<wmax2;loc++){
		
		// If you exit, you get nothing (Normalization) but you get the shock
		QMA[loc*(AMAX+1)]=0.0;
	
		for (a=1;a<=AMAX;a++){
		
		valest=0.0;
		
		for (k=0;k<VALSIMS;k++) {
		
		/* Draw a state tommorow */
		locprime=drawerconda(loc,a,binom,CUMPTRANZ,CUMDTRANZ,wmax,market,marketprime,marketother,ntuple);
	
		/* Figure out payoff from this action*/
		profitNP(theprofit,theta,locprime,loc,binom,wmax,markettoday,marketyesterday,pcomps,ntuple,DemandLevels);
	
		profitvalue=0.0;
		for(t=0;t<THETADIM;t++) 
			profitvalue=profitvalue+theta[t]*theprofit[t];
	
		thefuturevalue=0.0;
	
		/* Get tommorows value */
		for(j=0;j<=AMAX;j++)
			thefuturevalue=thefuturevalue+QMA[locprime*(AMAX+1)+j]*P[locprime*(AMAX+1)+j];
	
		/* Get the expected shock value */
		theshock=eulerc;

		for(j=0;j<=AMAX;j++) {
			h=P[locprime*(AMAX+1)+j];
			theshock=theshock-log(h+DUST)*h;
        	}
	
	
		// Add to sum
		valest=valest+profitvalue+beta*thefuturevalue+beta*theshock;
		}
		
		distval=distval+(QMA[loc*(AMAX+1)+a]-valest/VALSIMS)*(QMA[loc*(AMAX+1)+a]-valest/VALSIMS);
		totalval=totalval+valest/VALSIMS;
		// Update Choice Specific Value Function: Moving Average...
		QMA[loc*(AMAX+1)+a]=QMA[loc*(AMAX+1)+a]*0.1+0.9*valest/VALSIMS;
		}
		
	    // Update Choices 
	    choiceprobabilities(theta,P,QMA,loc,wmax2);
     	cumtranzeri(CUMPTRANZ,P,loc,(AMAX+1));
		}
		
		printf("Iteration %5i and Distance %5f, and mean value %5f \n", iterval,distval,totalval/(AMAX*wmax2));
	}


return 10;
}

/*--------------------------------------------------------*/
int Print_Profit(double theta[],double DemandLevels[],double parmvector[]) 
{
/* Decode Parameters */
struct SolutionParams_t thesolsparms;
struct SolutionParams_t * solsparms=&thesolsparms;
decodeparms(solsparms,parmvector);

	/* Build Standard Things */
	int * binom=malloc(sizeof(int)*(RLNFIRMS+SMAX+1)*(RLNFIRMS+SMAX+2));

	int i,k,j,t;
	
    /* Build the Binomial Matrix */
    int  wmax, wmax2, state;
    buildbinom(binom,&wmax,&wmax2);

	/* Set up state space */
	int loc, locprime, l, a, aprime, round;
	double theshock, alpha, u, distance, h;

    int ntuple[RLNFIRMS];
    struct market_t themarket;
    struct market_t * market=&themarket;
    struct market_t themarketprime;
    struct market_t * marketprime=&themarketprime;
    struct market_t themarketother;
    struct market_t * marketother=&themarketother;
    struct market_t themarkettoday;
    struct market_t * markettoday=&themarkettoday;
    struct market_t themarketyesterday;
    struct market_t * marketyesterday=&themarketyesterday;
    struct pcomp_t thepcomps;
    struct pcomp_t * pcomps=&thepcomps;

	int demand_i;
	double theprofit[THETADIM+1], profitvalue;


// Print Out a Profit
market->me=2;
market->demand=4;
loc=encode(market,binom,wmax,ntuple);

market->me=linkfunction(1,2);
market->demand=4;

/* Return the market vector */
for (i=0;i<RLNFIRMS;i++)
	market->tuple[i]=2;
locprime=encode(market,binom,wmax,ntuple);
profitNP(theprofit,theta,locprime,loc,binom,wmax,markettoday,marketyesterday,pcomps,ntuple,DemandLevels);

for(t=0;t<THETADIM;t++) 
	printf("component %5i and value %5f \n",t,theprofit[t]);



}
/*--------------------------------------------------------*/
int Value_Function_Pakes_McGuire2001(double theta[],double QMA[],double P[], double D[],double DemandLevels[],double hits[],double rhits[],double * thedistance,struct SolutionParams_t * solsparms, int seed)
{
	/* Build Standard Things */
	int * binom=malloc(sizeof(int)*(RLNFIRMS+SMAX+1)*(RLNFIRMS+SMAX+2));

	int i,k,j,t;
	int r, algorithm;
	double q, sum;

	double Qsquig, Qsq2, Test, Variance, Bias;
	double totalhits;

	r=0;
	srand ( seed);

    /* Build the Binomial Matrix */
    int  wmax, wmax2, state;
    buildbinom(binom,&wmax,&wmax2);

	/* Set up state space */
	int loc, locprime, l, a, aprime, round;
	double theshock, alpha, u, distance, h;

    int ntuple[RLNFIRMS];
    struct market_t themarket;
    struct market_t * market=&themarket;
    struct market_t themarketprime;
    struct market_t * marketprime=&themarketprime;
    struct market_t themarketother;
    struct market_t * marketother=&themarketother;
    struct market_t themarkettoday;
    struct market_t * markettoday=&themarkettoday;
    struct market_t themarketyesterday;
    struct market_t * marketyesterday=&themarketyesterday;
    struct pcomp_t thepcomps;
    struct pcomp_t * pcomps=&thepcomps;

if (solsparms->noisy>0.99)
	printf("WMAX %5i and wmax2 %5i \n",wmax,wmax2);
double theKSIMS=(double) solsparms->ksims;
int MAXITERS=(int) solsparms->maxiter;
int MAXROUNDS=(int) solsparms->maxround;
int simulatedata=solsparms->simulatedata;
int thetadimension=(int) solsparms->thetadim;
int KSIMS=(int) solsparms->ksims;
int bestresponse=(int) solsparms->brfs;
if (solsparms->noisy>0.99)
	printf("Maxiter %5i and Maxround %5i \n",MAXITERS,MAXROUNDS);

/* Make Cumulative Transitions */
double * CUMPTRANZ=malloc(sizeof(double)*wmax2*(AMAX+1));
if (  CUMPTRANZ == NULL){
	return 31;
}
cumtranzer(CUMPTRANZ,P,wmax2,(AMAX+1));

double * CUMDTRANZ=malloc(sizeof(double)*(MAXDEMAND+1)*(MAXDEMAND+1));
if ( CUMDTRANZ == NULL){
	return 32;
}
cumtranzer(CUMDTRANZ,D,MAXDEMAND+1,MAXDEMAND+1);

for (i=0;i<wmax2*(AMAX+1);i++)
	rhits[i]=0.0;


/* Get Value */
/* Stochastic Algorithm where I just get the best response*/
double averageQ, oldaQ, Qpos, profitvalue;
int tothits;

oldaQ=0.0;
averageQ=0.0;
Test=100.0;

/* Initial State */
loc=1;
a=1;

double theprofit[THETADIM+1];
double thefuturevalue;

int m;


/* Do this stuff in buckets of 1 Million Observations */

while (Test>TESTOL) {
for (round=0;round<MAXROUNDS;round++) {
for (k=0;k<MAXITERS;k++) {
	/* Draw a state tommorow */
	locprime=drawerconda(loc,a,binom,CUMPTRANZ,CUMDTRANZ,wmax,market,marketprime,marketother,ntuple);
	
	/* Figure out payoff from this action*/
	profitNP(theprofit,theta,locprime,loc,binom,wmax,markettoday,marketyesterday,pcomps,ntuple,DemandLevels);
	
	profitvalue=0.0;
	for(t=0;t<THETADIM;t++) 
		profitvalue=profitvalue+theta[t]*theprofit[t];
	
	
	thefuturevalue=0.0;
	
	/* Get tommorows value */
	for(j=0;j<=AMAX;j++)
		thefuturevalue=thefuturevalue+QMA[locprime*(AMAX+1)+j]*P[locprime*(AMAX+1)+j];
	
	/* Get the expected shock value */
	theshock=eulerc;

	for(j=0;j<=AMAX;j++) {
		h=P[locprime*(AMAX+1)+j];
		theshock=theshock-log(h+DUST)*h;
        }
	
	
	/* Update visits */
	hits[loc*(AMAX+1)+a]=hits[loc*(AMAX+1)+a]+1.0;
	rhits[loc*(AMAX+1)+a]=rhits[loc*(AMAX+1)+a]+1.0;

	alpha=hits[loc*(AMAX+1)+a];
	if (solsparms->alpharule==1.0)
		alpha=1.0/sqrt(alpha);
	if (solsparms->alpharule==2.0)
		alpha=1.0/alpha;

	// update V and location
	QMA[loc*(AMAX+1)+a]=QMA[loc*(AMAX+1)+a]*(1.00-alpha)+(profitvalue+beta*thefuturevalue+beta*theshock)*alpha;
	
	
	// If you exit, you get nothing (Normalization) but you get the shock
	if (a==0)
		QMA[loc*(AMAX+1)+a]=0.0;

		
		
	// Update Choices 
	if (bestresponse==1) {
		choiceprobabilities(theta,P,QMA,loc,wmax2);
		cumtranzeri(CUMPTRANZ,P,loc,(AMAX+1));
	}

		// Update Start State 
		loc=locprime;
	    /* Draw an action tommorow */
		u=(double) rand ()/(RAND_MAX + 1.00);
		for (j=0;(CUMPTRANZ[locprime*(AMAX+1)+j]<u);j++);
		a=j;
		
	// Every so often just throw the state somewhere else in the state space (avoid getting trapped in a small reccurent state
	if (((k/500)==0)&&(round<(MAXROUNDS-2))) {
		u=(double) rand ()/(RAND_MAX + 1.00);
		loc=(int)(u*(double) wmax2);
		u=(double) rand ()/(RAND_MAX + 1.00);
		a=(int)(u*(double) AMAX);
		}

	
	}
	if (solsparms->noisy>0.99)
	printf("Round %5i \n",round);

double todayprofit=QMA[loc*(AMAX+1)+a];

//todayprofit=beta*thefuturevalue;

if (solsparms->noisy>0.99)
printf("Q %5f in state %5i and action %5i and Hits %5f \n", todayprofit,loc,a,hits[loc*(AMAX+1)+a]);
int pos,js,ergodicstates;
double thefv,theprof, Diff, xsum, ysum, xsq, ysq, xysum,xsum1, ysum1, xsq1, ysq1, xycross, top, sx, sy, n, correlation, correlation1;

/* Switch to bypass test*/
if (solsparms->test<0.99)
	Test=-1.0;


if ((round==(MAXROUNDS-1))&&(solsparms->test>0.99)) {
/* Pakes-Fershmann Stopping Criteria */
	/* Forward simulation for states that are recurrent */
	Test=0.0;
	Diff=0.0;
	totalhits=0;
	ergodicstates=0;
	xsum=0.0;
	ysum=0.0;
	xsq=0.0;
	ysq=0.0;
	xysum=0.0;
	xsum1=0.0;
	ysum1=0.0;
	xsq1=0.0;
	ysq1=0.0;
	xycross=0.0;
	theprof=0.0;

	for (i=0;i<wmax2;i++) {
		for (js=1;js<(AMAX+1);js++) /* Omit Action 0 states */{

		pos=i*(AMAX+1)+js;
		/* Only States that are recurrent */
		if (rhits[pos]>1) {
			Qsquig=0.0;
			Qsq2=0.0;
			Qpos=0.0;
			ergodicstates++;
			/* Value from Q function */
			Qpos=QMA[i*(AMAX+1)+js];
			
			for (k=0;k<KSIMS;k++) {
			/* Draw states */
			locprime=drawerconda(i,js,binom,CUMPTRANZ,CUMDTRANZ,wmax,market,marketprime,marketother,ntuple);

			/* Figure out payoff from this action*/
			/* Get the profitNP */
			profitNP(theprofit,theta,locprime,i,binom,wmax,market,marketprime,pcomps,ntuple,DemandLevels);
			theprof=0.0;
			for (t=0;t<THETADIM;t++)
				theprof=theprof+theta[t]*theprofit[t];
			
			thefv=0.0;

			/* Get tommorows value */
			for(j=0;j<(AMAX+1);j++)
				thefv=thefv+QMA[locprime*(AMAX+1)+j]*P[locprime*(AMAX+1)+j];

			/* Get the expected shock value */
			theshock=eulerc;

			for(j=0;j<=AMAX;j++) {
				h=P[locprime*(AMAX+1)+j];
				theshock=theshock-log(h+DUST)*h;
        		}
	
				
			Qsquig=Qsquig+(theprof+beta*thefv+beta*theshock);
			Qsq2=Qsq2+(theprof+beta*thefv+beta*theshock-Qpos)*(theprof+beta*thefv+beta*theshock-Qpos);
			/* Stuff for sample correlation */
			ysq=ysq+Qpos*Qpos/theKSIMS;
			ysum=ysum+Qpos/theKSIMS;

			xsq=xsq+(theprof+beta*thefv+beta*theshock)*(theprof+beta*thefv+beta*theshock)/theKSIMS;
			xsum=xsum+(theprof+beta*thefv+beta*theshock)/theKSIMS;

			xysum=xysum+Qpos*(theprof+beta*thefv+beta*theshock)/theKSIMS;
			}

			Qsquig=Qsquig/theKSIMS;
			/*printf(" State %5i Action %5i Hits %5f Qsquig %5f Qpos %5f \n",i,js,rhits[pos],Qsquig,Qpos);*/
			Qsq2=Qsq2/(theKSIMS-1);

			xsum1=xsum1+Qpos*(rhits[pos]);
			ysum1=ysum1+Qsquig*(rhits[pos]);
			xsq1=xsq1+Qpos*Qpos*(rhits[pos]);
			ysq1=ysq1+Qsquig*Qsquig*(rhits[pos]);
			xycross=xycross+Qpos*Qsquig*(rhits[pos]);

			Diff=Diff+fabs(Qpos-Qsquig)*(rhits[pos]);
			Bias=((Qpos-Qsquig)*(Qpos-Qsquig)-Qsq2)/(Qpos*Qpos);

			Test=Test+Bias*(rhits[pos]);
			totalhits=totalhits+rhits[pos];
		}
		}
	}
if (solsparms->noisy>0.99) {
	/* Correlation */
	n=(double) ergodicstates;
	top=(n*xysum-xsum*ysum);
	sx=sqrt(n*xsq-xsum*xsum);
	sy=sqrt(n*ysq-ysum*ysum);
	correlation=top/(sx*sy);

	top=(xycross-xsum1*ysum1/totalhits);
	sx=sqrt(xsq1-xsum1*xsum1/totalhits);
	sy=sqrt(ysq1-ysum1*ysum1/totalhits);

	correlation1=top/(sx*sy);


	printf("Mean Qsquig %5f Mean Qpos %5f  \n",ysum1/totalhits,xsum1/totalhits);
	printf("Total Hits %3f ",totalhits);}
	printf("Difference %3f \n",Diff/totalhits);
	printf("Correlation %3f \n",correlation);
	printf("Correlation Accross Sims %3f \n",correlation1);
	printf("Number of Ergodic States %3i \n",ergodicstates);
	/* Test Statistic */
    Test=Test/((double) totalhits);
    Test=-100*(correlation1>0.99);
if (solsparms->noisy>0.99)
	printf(" Test %5f \n",Test);

    }

/* Reset Recent Hits */
if( round<(MAXROUNDS-1)){
  for (i=0;i<wmax2*(AMAX+1);i++)
           rhits[i]=0.0; }

}
}


/* Allocation Time */
*thedistance=Test;


/* Free Stuff you've used */
free(binom);
free(CUMPTRANZ);
free(CUMDTRANZ);

if (solsparms->noisy>0.99)
	printf("Done with this call \n");

return 10;
}
/*-------------------------------------------------------------------------------*/
int Value_Stochastic_Algorithm(double * theta,double * Q, double * P, double * D, double * DemandLevels, double *thehits, double *recenthits,double * thedistance, double * returncode,double * parmvector, double * seed)
{

/* Decode Parameters */
struct SolutionParams_t thesolsparms;
struct SolutionParams_t * solsparms=&thesolsparms;
decodeparms(solsparms,parmvector);
int seeder;
double seedhold;
seedhold=*seed;

seeder=(int) (seedhold);
if (solsparms->noisy>0.99)
printf("Hello \n");

*returncode=(double)Value_Function_Pakes_McGuire2001(theta,Q,P,D,DemandLevels,thehits,recenthits,thedistance,solsparms,seeder);
if (solsparms->noisy>0.99)
printf("Goodbye \n");
return 1;
}
/*-------------------------------------------------------------------------------*/
int Value_Iteration_Monte_Carlo(double * theta,double * Q, double * P, double * D, double * DemandLevels, double *thehits, double *recenthits,double * thedistance, double * returncode,double * parmvector, double * seed)
{

/* Decode Parameters */
struct SolutionParams_t thesolsparms;
struct SolutionParams_t * solsparms=&thesolsparms;
decodeparms(solsparms,parmvector);
int seeder;
double seedhold;
seedhold=*seed;

seeder=(int) (seedhold);
if (solsparms->noisy>0.99)
printf("Hello \n");

*returncode=(double)Value_Iteration_Simulation(theta,Q,P,D,DemandLevels,thehits,recenthits,thedistance,solsparms,seeder);
if (solsparms->noisy>0.99)
printf("Goodbye \n");
return 1;
}
/*-------------------------------------------------------------------------------*/
int simulate_condP(double predicted_action[],double statedata[], double datasize[], double P[], double D[], double parmvector[])
{
	
	/* Decode Parameters */
struct SolutionParams_t thesolsparms;
struct SolutionParams_t * solsparms=&thesolsparms;
decodeparms(solsparms,parmvector);
    int ntuple[RLNFIRMS];
    struct market_t themarket;
    struct market_t * market=&themarket;
    struct market_t themarketprime;
    struct market_t * marketprime=&themarketprime;
    struct market_t themarketother;
    struct market_t * marketother=&themarketother;
    struct market_t themarkettoday;
    struct market_t * markettoday=&themarkettoday;
    struct market_t themarketyesterday;
    struct market_t * marketyesterday=&themarketyesterday;
    struct pcomp_t thepcomps;
    struct pcomp_t * pcomps=&thepcomps;
	/* Build Standard Things */
	int * binom=malloc(sizeof(int)*(RLNFIRMS+SMAX+1)*(RLNFIRMS+SMAX+2));
	
    	/* Build the Binomial Matrix */
    	int  wmax, wmax2, state, t;
    	buildbinom(binom,&wmax,&wmax2);
	
	/* Make Cumulative Transitions */
	double * CUMPTRANZ=malloc(sizeof(double)*wmax2*(AMAX+1));
	if (  CUMPTRANZ == NULL){
		return 31;
	}
	cumtranzer(CUMPTRANZ,P,wmax2,(AMAX+1));
	
	double * CUMDTRANZ=malloc(sizeof(double)*(MAXDEMAND+1)*(MAXDEMAND+1));
	if ( CUMDTRANZ == NULL){
		return 32;
	}
	cumtranzer(CUMDTRANZ,D,MAXDEMAND+1,MAXDEMAND+1);
	
	int n, j ,i,loc,a,locprime;
	double u;

	for (n=0; n<(int) datasize[0]; n++) { 	
	loc=statedata[n];
	
	u=(double) rand ()/(RAND_MAX + 1.00);
	for (j=0;(CUMPTRANZ[loc*(AMAX+1)+j]<u);j++);
	a=j;
	predicted_action[n]=(double) j;
	}	


	free(CUMPTRANZ);
	return 1;
}

